<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
    include("head.php");

    This("addressbook/");
    Head();

?>

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>
<TR><TD HEIGHT=20></TD></TR>
<TR><TD><center><H1> Manage Address Book </H1></center></TD></TR>

<TR><TD><center>(only external addresses without a kolab user account)</center></TD></TR>

<?

$utf8 = array ( 'cn', 'sn' );

$errors = array();

// check user authentication 
if (!($uid = $_SERVER["PHP_AUTH_USER"]) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid))) 
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "admin" && $group != "maintainer") 
   array_push($errors, "Error: You don't have Permissions to access this Menue");

// read selector for register display
if (isset($HTTP_GET_VARS['alphaselect'])) $alphaselect = $HTTP_GET_VARS['alphaselect'];
   else $alphaselect = "[A-F]";

$myself = $_SERVER['PHP_SELF'];

if (isset($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (isset($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

   //JMD: use myldap_connect
if (!$errors && !($link = myldap_connect($ldap_server,$ldap_port)) || !ldap_bind($link)) 
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($link));   

switch ($alphaselect) {
   case "[A-F]":
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=*))(|(sn=F*)(sn=E*)(sn=D*)(sn=C*)(sn=B*)(sn=A*)"; 
      $filter = $filter."(sn=f*)(sn=e*)(sn=d*)(sn=c*)(sn=b*)(sn=a*)";
      if (in_array('sn', $utf8)) $filter = $filter."(sn=".utf8_encode("")."*)(sn=".utf8_encode("")."*)";
      $filter = $filter."))";
      break;

   case "[G-L]":
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=*))(|(sn=G*)(sn=H*)(sn=I*)(sn=J*)(sn=K*)(sn=L*)";
      $filter = $filter."(sn=g*)(sn=h*)(sn=i*)(sn=j*)(sn=k*)(sn=l*)))";
      break;

   case "[M-S]":
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=*))(|(sn=M*)(sn=N*)(sn=O*)(sn=P*)(sn=Q*)(sn=R*)(sn=S*)";
      $filter = $filter."(sn=m*)(sn=n*)(sn=o*)(sn=p*)(sn=q*)(sn=r*)(sn=s*)";
      if (in_array('sn', $utf8)) $filter = $filter."(sn=".utf8_encode("")."*)(sn=".utf8_encode("")."*)".
                                                   "(sn=".utf8_encode("")."*)(sn=".utf8_encode("")."*)";
      $filter = $filter."))";
      break;

   case "[T-Z]":
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=*))(|(sn=T*)(sn=U*)(sn=V*)(sn=W*)(sn=X*)(sn=Y*)(sn=Z*)";
      $filter = $filter."(sn=t*)(sn=u*)(sn=v*)(sn=w*)(sn=x*)(sn=y*)(sn=z*)))";
      break;

   default: 
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=*))(sn=*))";
      break;
}

if (!$errors) {

$result = ldap_search($link, $_SESSION['base_dn'], $filter);
if ($result) {
   print("<tr><td><center><form method=\"POST\" action=\"$myself\">\n<h2>\n");
   $text = "[A-F]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>");
   $text = "[G-L]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>");
   $text="[M-S]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>");
   $text="[T-Z]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>");
   $text="[all]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;&nbsp;$text&nbsp;&nbsp;</a>\n");
   print("</h2></form></center></td></tr>");
   print("<TR><TD HEIGHT=20></TD></TR>\n");

   print("<TD ALIGN=center>\n");
   print("<TABLE WIDTH=95% BORDER=1 CELLSPACING=0 bgcolor=\"#dcdcdc\" CELLPADDING=3 nosave>\n");
   ldap_sort($link,$result,'sn');
   $entry = ldap_first_entry($link, $result);
   if (ldap_count_entries($link,$result) <= 0) { 
      print("<tr><td align=center> (No external address book entries in the category $alphaselect) </td></tr>\n");
   } else {
      printf("<thead><td><b> Name </b></td><td><b> Action </b></td></thead>\n");
      while ($entry) {   
         $dn = ldap_get_dn($link,$entry);
         $attrs = ldap_get_attributes($link, $entry);
         $sn = $attrs['sn'][0];
         if (in_array('sn', $utf8)) $sn = utf8_decode($sn);
         $cn = $attrs['cn'][0];
         if (in_array('cn', $utf8)) $cn = utf8_decode($cn);
         $a = strlen($sn);
         $b = strlen($cn); 
         $fn = substr($cn, 0, $b - $a);
         $dn = urlencode($dn);
         printf("<tr align=center><td> %s, %s </td><td>
                 <a href=\"create_vcard.php?action=modify&dn=%s\"> [Modify]</a>
                 <a href=\"create_vcard.php?action=delete&dn=%s\"> [Delete]</a>
	         </td></tr>\n", $sn, $fn, $dn,$dn);
         $entry = ldap_next_entry($link, $entry);
      } 
      ldap_free_result($result);
   }
   ldap_close($link);
} else array_push($errors, "Communication Error: ldap server did not answer query for user information");

}
print("</table>\n");

if ($errors) {
   print("<TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>"); 
   print("</TD></TR>\n");
   print("</TABLE>\n");
}

Foot(); 
?>
