<?php
// (C) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
// This program is Free Software under the GNU General Public License (>=v2).
// Read the file COPYING that comes with this packages for details.

if($is_system==0) {
   unset($oc_orig['posixAccount']);
   unset($oc_orig['shadowAccount']);
   unset($oc_orig['sambaSamAccount']);
} else {
   if(!$ldap_object['uidNumber'][0]) {
      $cmd ="/etc/kolab/incrementuid.pl ldap://";
      $cmd.=$_SESSION['ldap_server'].":";
      $cmd.=$_SESSION['ldap_port']." ";
      $cmd.=$_SESSION['base_dn']." ";
      $cmd.=$_SESSION['php_dn']." ";
      $cmd.=$_SESSION['php_pw'];
      $tmpid=explode(':',`$cmd`);
      if($tmpid[0]=="UIDOK") {
        $ldap_object['uidNumber'][0]=rtrim($tmpid[1]);
      }
   }
   if(!$ldap_object['uidNumber'][0]) {
        $comment['uidNumber_0'] = "<span style=\"color:#FF0000\">Required for system users</span>";
   }
   //JMD: The control is now a drop-down box, so this is needed
   $ldap_object['gidNumber'][0]=$HTTP_GET_VARS['gidNumber_0'];
   if(!$ldap_object['gidNumber'][0]) {
      $ldap_object['gidNumber'][0]="999";
   }
   if(!$ldap_object['homeDirectory']) {
      if($ldap_object['uid']) {
        $ldap_object['homeDirectory']="/home/".$ldap_object['uid'];
      } else {
        $ldap_object['homeDirectory']="/home/".$orig_object['uid'][0];
      }
   }
   if(!$ldap_object['loginShell'][0]) {
      $ldap_object['loginShell'][0]="/bin/bash";
   }

   $SAMBASID=`cat /etc/kolab/sambasid`;

   if(!$ldap_object['sambaSID'][0] && $ldap_object['uidNumber'][0] && $SAMBASID) {
      $theid=1000+(($ldap_object['uidNumber'][0])*2);
      $ldap_object['sambaSID'][0]=$SAMBASID."-".$theid;
   }      
   if(!$ldap_object['sambaPrimaryGroupSID'][0] && $ldap_object['gidNumber'][0] && $SAMBASID) {
      $theid=1001+(($ldap_object['gidNumber'][0])*2);
      $ldap_object['sambaPrimaryGroupSID'][0]=$SAMBASID."-".$theid;
   }      
   if(!$ldap_object['sambaAcctFlags'][0]) {
      $ldap_object['sambaAcctFlags'][0]="[U          ]";
   }
   if(!$ldap_object['displayName'][0]) {
      $ldap_object['displayName'][0]=$ldap_object['cn'];
   }
   if(!$ldap_object['gecos'][0]) {
      $ldap_object['gecos'][0]=$ldap_object['cn'];
   }
   if($ldap_object['uidNumber'][0] &&
      $ldap_object['gidNumber'][0] &&
      $ldap_object['homeDirectory'][0]) {
         $oc_orig['posixAccount']=1;
         $ldap_object['objectClass'][]='posixAccount';
   }
   if($ldap_object['sambaSID'][0]) {
      $oc_orig['sambaSamAccount']=1;
      $ldap_object['objectClass'][]='sambaSamAccount';
   }
   $oc_orig['shadowAccount']=1;
   $ldap_object['objectClass'][]='shadowAccount';
}

unset($orig_object['objectClass']);
foreach($oc_orig as $key=>$value) { $orig_object['objectClass'][]=$key; }

//debug2("Original ObjectClass:",$oc_orig);
//debug2("Modified ObjectClass:",$orig_object['objectClass']);
//debug2("LDAP Object:",$ldap_object);

?>
