<?
/*
 (c) 2005 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
//  include("../user/head.php");

$errors = array();

// check user authentication 
if (!($uid = $_SERVER["PHP_AUTH_USER"]) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid))) 
   array_push($errors, "Internal Error: could not get Authentication Information");

if (isset($_SESSION['base_dn'])) $base_dn = $_SESSION['base_dn'];
   else $base_dn = 'k=kolab' ;

$myself = $_SERVER['PHP_SELF'];

if (isset($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (isset($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

//JMD: use myldap_connect
if (!$errors && !($group_link = myldap_connect($ldap_server,$ldap_port)) || !ldap_bind($group_link,$bind_dn,$_SERVER["PHP_AUTH_PW"])) 
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($group_link));   

$group_filter="(objectclass=posixGroup)";

if (!$errors) {
$group_result = ldap_search($group_link, $base_dn, $group_filter);
if ($group_result) {
   ldap_sort($group_link,$group_result,'cn');
   $group_entry = ldap_first_entry($group_link, $group_result);
   if (!$group_entry) { 
      print("No groups!");
   } else {
      while ($group_entry) {   
         $group_dn = ldap_get_dn($group_link,$group_entry);
         $group_attrs = ldap_get_attributes($group_link, $group_entry);
         $groups.="<Option value=";
         $groups.=$group_attrs['gidNumber'][0];
         if($selgid==$group_attrs['gidNumber'][0]) { $groups.=" SELECTED "; }
         $groups.=">";
         $groups.=$group_attrs['cn'][0];
         $groups.="</Option>\n";
         //print_r($group_attrs);       
         $group_entry = ldap_next_entry($group_link, $group_entry);
      } 
      ldap_free_result($group_result);
   }
   ldap_close($group_link);
} else array_push($errors, "Communication Error: ldap server did not answer query for user information");

}

if ($errors) {
   print "There were errors:";
   foreach ($errors as $message) echo $message;
}

?>
