<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("service/");
  Head();
?>

<TABLE ALIGN=CENTER WIDTH=90%>
<TR><TD HEIGHT=20></TD></TR>
<TR><TD><CENTER><H1>Enable or Disable individual Services</H1></CENTER></TD></TR>
<TR><TD>
<p>Using legacy services poses a security thread due to leakage of cleartext passwords, lack of authenticity and privacy.</p>
<p>The legacy Freebusy Support (FTP and HTTP) is only required for Outlook2000 clients. 
Under all other circumstances it is advised to use the secure <a href="http://www.webdav.org">WebDAV</a> 
over TLS instead (WebDAV is enabled by default and may not be deactivated).</p>
<p>Further details with regards to security considerations are available on the 
internet at the <a href="http://kolab.kde.org">Kolab</a> webserver.  </p></TD></TR>
<TR><TD HEIGHT=20></TD></TR>
<TD><CENTER>

<?
function debug ($a) {
//   print "debug: $a<br>\n";
}

debug("debug is on");
$errors = array();

// read environment/server variables and connect to LDAP server
if (!($uid = $_SERVER['PHP_AUTH_USER']) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid)))
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "admin")
   array_push($errors, "Error: You don't have the required Permissions");

debug("givenuid=$uid, bind_dn=$bind_dn, group=$group");

$myself = $_SERVER['PHP_SELF'];

if (!empty($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (!empty($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

//JMD: use myldap_connect
if (!$errors && (!($link = myldap_connect($ldap_server,$ldap_port)) ||
    !ldap_bind($link, $bind_dn, $_SERVER["PHP_AUTH_PW"])))
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($link));

$allowed = array('TRUE','FALSE'); // implement LDAP Boolean Syntax
$attrs = array();
if (!empty($HTTP_GET_VARS['pop3'])) {
   $pop3 = urldecode($HTTP_GET_VARS['pop3']);
   if (in_array($pop3, $allowed)) $attrs['cyrus-pop3'] = $pop3; 
}

if (!empty($HTTP_GET_VARS['pop3s'])) {
   $pop3s = urldecode($HTTP_GET_VARS['pop3s']);
   if (in_array($pop3s, $allowed)) $attrs['cyrus-pop3s'] = $pop3s;
}

if (!empty($HTTP_GET_VARS['imaps'])) {
   $imaps = urldecode($HTTP_GET_VARS['imaps']);
   if (in_array($imaps, $allowed)) $attrs['cyrus-imaps'] = $imaps;
}

if (!empty($HTTP_GET_VARS['ftp'])) {
   $ftp= urldecode($HTTP_GET_VARS['ftp']);
   if (in_array($ftp, $allowed)) $attrs['proftpd-ftp'] = $ftp;
}

if (!empty($HTTP_GET_VARS['http'])) {
   $http= urldecode($HTTP_GET_VARS['http']);
   if (in_array($http, $allowed)) $attrs['apache-http'] = $http;
}

if (!empty($HTTP_GET_VARS['sieve'])) {
   $sieve = urldecode($HTTP_GET_VARS['sieve']);
   if (in_array($sieve, $allowed)) $attrs['cyrus-sieve'] = $sieve;
}

#array_push($errors, "http $http ftp $ftp imap $imap imaps $imaps pop3 $pop3 pop3s $pop3s sieve $sieve");

if ( ( isset($http) || isset($ftp) || isset($imaps) || 
       isset($pop3) || isset($pop3s) || isset($sieve) ) && 
       !($result = ldap_modify($link, "k=kolab,".$_SESSION['base_dn'], $attrs)) )
     array_push($errors, "LDAP Error: failed to modify kolab configuration object ".ldap_error($link));

if (($result = ldap_read($link, "k=kolab,".$_SESSION['base_dn'], '(objectclass=*)')) &&
    ($entry = ldap_first_entry($link, $result)) &&
    ($attrs = ldap_get_attributes($link, $entry))) {
   $pop3 = $attrs['cyrus-pop3'][0];
   $pop3s = $attrs['cyrus-pop3s'][0];
   $imap = $attrs['cyrus-imap'][0];
   $imaps = $attrs['cyrus-imaps'][0];
   $sieve = $attrs['cyrus-sieve'][0];
   $ftp = $attrs['proftpd-ftp'][0];
   $http = $attrs['apache-http'][0];
   ldap_free_result($result);
}
?>

<TABLE WIDTH=75% BORDER=1 CELLSPACING=0 bgcolor="#dcdcdc" CELLPADDING=3 nosave align=center>
<tr><th> Service </th><th> Status </th><th> Action </th></tr>
<tr><center><td> POP3 service </td><td> 
<? if ($pop3=="TRUE") 
   print("<span style=\"color:#00FF00\">active</span></td><td><a href=\"index.php?pop3=FALSE\">disable pop3</a>"); 
   else print("<span style=\"color:#FF0000\">disabled</span></td><td><a href=\"index.php?pop3=TRUE\">activate pop3</a>"); 
?></td></center></tr>

<tr><center><td> POP3/SSL service (TCP port 995) </td><td> 
<? if ($pop3s=="TRUE")
   print("<span style=\"color:#00FF00\">active</span></td><td><a href=\"index.php?pop3s=FALSE\">disable pop3s</a>");
   else print("<span style=\"color:#FF0000\">disabled</span></td><td><a href=\"index.php?pop3s=TRUE\">activate pop3s</a>");
?></td></center></tr>

<tr><center><td> IMAP service </td><td> 
<? if ($imap=="TRUE") 
   print("<span style=\"color:#00FF00\">active</span></td><td>(may not be deactivated)");
?></td></center></tr>

<tr><center><td> IMAP/SSL service (TCP port 993) </td><td> 
<? if ($imaps=="TRUE")
   print("<span style=\"color:#00FF00\">active</span></td><td><a href=\"index.php?imaps=FALSE\">disable imaps</a>");
   else print("<span style=\"color:#FF0000\">disabled</span></td><td><a href=\"index.php?imaps=TRUE\">activate imaps</a>");
?> </td></center></tr> 

<tr><center><td> Sieve service (TCP port 2000) </td><td> 
<? if ($sieve=="TRUE") 
   print("<span style=\"color:#00FF00\">active</span></td><td><a href=\"index.php?sieve=FALSE\">disable sieve</a>");
   else print("<span style=\"color:#FF0000\">disabled</span></td><td><a href=\"index.php?sieve=TRUE\">activate sieve</a>");
?> </td></center></tr> 

<tr><center><td> FTP free-busy service </td><td>
<? if ($ftp=="TRUE") 
   print("<span style=\"color:#00FF00\">active</span></td><td><a href=\"index.php?ftp=FALSE\">disable ftp</a>");
   else print("<span style=\"color:#FF0000\">disabled</span></td><td><a href=\"index.php?ftp=TRUE\">activate ftp</a>"); 
?></td></center></tr>

<tr><center><td> HTTP free-busy service </td><td>
<? if ($http=="TRUE") 
   print("<span style=\"color:#00FF00\">active</span></td><td><a href=\"index.php?http=FALSE\">disable http</a>");
   else print("<span style=\"color:#FF0000\">disabled</span></td><td><a href=\"index.php?http=TRUE\">activate http</a>"); 
?>
</td></center></tr>

<!-- <tr><center><td> HTTPS service (TCP port 443) </td>
<td> <span style="color:#00FF00">active</span></td><td> (informational) </td></center></tr>

<tr><center><td> SMTP service (TCP port 25) </td>
<td> <span style="color:#00FF00">active</span></td><td> (informational) </td></center></tr>

<tr><center><td> LDAP service (TCP port 389) </td>
<td> <span style="color:#00FF00">active</span></td><td> (informational) </td></center></tr>
-->

</table>

<?
if ($errors) {
   print("<TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>");
   print("</TD></TR>\n");
   print("</TABLE>\n");
}
?>
</CENTER></TD></TR></TABLE>
</FONT>
<?  Foot();  ?>
