<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("sharedfolder/create_sharedfolder.php?action=create");
  Head();
?>

<P>
</FONT>
<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>
<TR><TD HEIGHT=20></TD></TR>
<TR><TD><CENTER>

<?  

function debug ($a)
{
//   print "debug: $a<br>\n";
}

debug("debug is on");

$myentry = array (
      0 => 'cn', 'cn' => array(0 => "", 'count' => 1),
      1 => 'acl', 'acl' => array(0 => "", 'count' => 1),
      2 => 'cyrus-userquota', 'cyrus-userquota' => array(0 => "", 'count' => 1),
      'count' => 3 );

$comment = array('cn_0' => "Required",
		 'acl_0' => "Required",
                 'cyrus-userquota_0' => "Optional");

$errors = array();

function comment ($a)
{
   global $comment;
   if (array_key_exists($a, $comment)) return $comment[$a];
   return "";
}

$noshow = array('objectClass');

function noshow ($a)
{
   global $noshow;
   return in_array($a, $noshow);
}

$blacklist = array( 'cn' );

function black ($a)
{
   global $blacklist;
   return in_array($a,$blacklist);
}

$beautify = array ( 'cn' => 'Folder Name', 'acl' => 'Permissions for UID:',
                    'cyrus-userquota' => 'Quota Limit (KByte)');

function beautify ($a) 
{
   global $beautify;
   if (array_key_exists($a, $beautify)) return $beautify[$a];
   return $a;
}

$valid_actions = array( 'save','firstsave','modify','create','delete' );

if (!empty($HTTP_GET_VARS['action']) &&
    in_array($HTTP_GET_VARS['action'],$valid_actions)) $action = trim(urldecode($HTTP_GET_VARS['action']));
   else array_push($errors, "Error: need valid action to proceed");


$dn="";
if (!empty($HTTP_GET_VARS['dn'])) $dn = trim(urldecode($HTTP_GET_VARS['dn']));

if (!($uid = $_SERVER['PHP_AUTH_USER']) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid)))
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "admin" && $group != "maintainer")
   array_push($errors, "Error: You don't have the required Permissions");

debug("givenuid=$uid, bind_dn=$bind_dn, dn='$dn', group=$group");

$myself = $_SERVER['PHP_SELF'];

if (!empty($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (!empty($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;


//JMD: use myldap_connect
if (!$errors && (!($link = myldap_connect($ldap_server,$ldap_port)) ||
    !ldap_bind($link, $bind_dn, $_SERVER["PHP_AUTH_PW"])))
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($link));
if (!$errors) {

   $attrs = array( 'objectClass' => 'kolabSharedfolder');

   if ($action == "delete") {
      if (!$dn) array_push($errors, "Internal Error: need dn to delete shared folder");
      else {
         print("<TR><TD><center><H1> Delete Shared Folder </H1></center></TD></TR>\n");
         $attrs['kolabDeleteflag'][0] = 'TRUE';
         if (!(ldap_modify($link,$dn,$attrs))) {
            array_push($errors, "LDAP Error: could not mark ".utf8_decode($dn)." for deletion ".ldap_error($link));
	 } else {
	    //system("sudo -u kolab /kolab/etc/kolab/kolab_buildconfig &");
	    print("<tr><td><center> The object ".utf8_decode($dn)." has been deleted </td></tr>\n");
	 }
      }
   } else {

   switch ($action) {
      case "save":
      case "firstsave":

         if ($action == "save" && !$dn) {
            array_push($errors, "Internal Error: need dn argument to save object");
            $action = "modify";
            break;
         }
         for ($i=0; $i<$myentry['count']; $i++) {
            $attr = $myentry[$i];
            if (black($attr)) continue;
            $count = 0;
            $key = $attr."_0";
            while (!empty($HTTP_GET_VARS[$key])) {
               $attrs[$attr][$count] = trim(urldecode($HTTP_GET_VARS[$key]));
               $count++;
               $key = $attr."_".$count;
            }
         }
         $count = 0;
         $key1 = "user_$count";
         $key2 = "permission_$count";
         while (!empty($HTTP_GET_VARS[$key1]) && !empty($HTTP_GET_VARS[$key2])) {
            $attrs['acl'][$count] = $HTTP_GET_VARS[$key1]." ".$HTTP_GET_VARS[$key2];  
            $count++;
            $key1 = "user_$count";
            $key2 = "permission_$count";
         }
         if ($action == "firstsave") {
            if (empty($HTTP_GET_VARS['cn_0'])) {
               $comment['cn_0'] = "<span style=\"color:#FF0000\"> Fill in Folder name </span>";
            } else {
               $attrs['cn'][0] = trim(urldecode($HTTP_GET_VARS['cn_0']));
               $dn = "cn=".(utf8_encode($attrs['cn'][0])).",".$_SESSION['base_dn'];
            }
         }
         $myentry = array_merge_recursive($myentry,$attrs);
	 if (!empty($myentry['cn'][0])) {
	    $myentry['cn'][0] = utf8_encode($myentry['cn'][0]);
	    $attrs['cn'][0] = utf8_encode($attrs['cn'][0]);
	 }
         if ($errors) {
            $dn = "";
            $blacklist = array();
            $action = "create";
            break;
         }
         if ($action == "save") {
            if (!ldap_mod_replace($link,$dn,$attrs))
               array_push($errors, "LDAP Error: could not write to ldap object $dn");
         } else {
            if ($dn && !ldap_add($link,$dn,$attrs)) {
               array_push($errors, "LDAP Error: could not add $dn to ldap (entry already exists) ".ldap_error($link));
               print("<TR><TD><center><H1> Create New Shared Folder </H1></center></TD></TR>\n");
               $action = "create";
               $blacklist = array();
	       break;
            } 
         }
	 //system("sudo -u kolab /kolab/etc/kolab/kolab_buildconfig &");
         $blacklist = array('cn');
         $action = "modify";
         print "<h1> Modify Existing Shared Folder </h1>\n";
         break;

      case "create":
         print "<h1> Create New Shared Folder </h1>\n";
         $blacklist=array();
         break;

      case "modify":
         print "<h1> Modify Existing Shared Folder </h1>\n";
         $blacklist = array('cn');
         break;
   }

   if ($dn) {
      $attrs = array();
      if (($result = ldap_read($link, $dn, "(objectClass=*)")) &&
          ($entry = ldap_first_entry($link,$result)) &&
          ($attrs = ldap_get_attributes($link,$entry))) {
         //$myentry = array_merge_recursive($myentry,$attrs);
         for ($i=0; $i<$attrs['count']; $i++) {
            $attr = $attrs[$i];
            $myentry[$attr] = $attrs[$attr];
         }
         //array_push($myentry['acl'],"");
	 if (!empty($HTTP_GET_VARS['adduser'])) $adduser = trim(urldecode($HTTP_GET_VARS['adduser']));
	    else $adduser = "";
         $myentry['acl'][$myentry['acl']['count']] = $adduser;
         $myentry['acl']['count']++;
	 $myentry['cn'][0] = utf8_decode($myentry['cn'][0]);
         ldap_free_result($result);
      } else array_push($errors, "LDAP Error: could not read dn ".ldap_error($link));
   }

   }
   ldap_close($link);
} 

//print "myentry: ";
//print_r($myentry);
//print "<br>";

if ($action != "delete") {

print "<form action=\"$myself\" method=\"GET\">\n";
if ($action == "create") {
   print "<input type=\"hidden\" name=\"action\" value=\"firstsave\">\n";
} else {
   print "<input type=\"hidden\" name=\"action\" value=\"save\">\n";
}
if ($dn) print "<input type=\"hidden\" name=\"dn\" value=\"$dn\">\n";
print "<table cellspacing=\"0\" cellpadding=\"3\">\n";
print "<tr><th> Attribute </th><th> Value </th><th> Option </th><th> Comment </th></tr>\n";


$options = array( 0 => 'none', 'none' => '',
                  1 => 'read', 'read' => '',
		  2 => 'post', 'post' => '',
 		  3 => 'append', 'append' => '',
 		  4 => 'write', 'write' => '',
		  5 => 'all', 'all' => '',
                  'count' => 6);

for ($i=0; $i<$myentry['count']; $i++) {
   $attr = $myentry[$i];
   if (!(noshow($attr))) {
      $values = $myentry[$attr];
      for ($j=0; $j<$myentry[$attr]['count']; $j++) {
         $battr = beautify($attr);
         $value = $myentry[$attr][$j];
         print "<tr><td> $battr </td>\n";
         if (!black($attr)) {
            if ($attr == "acl") {
               $user = $value = "";
               if (!empty($myentry['acl'][$j])) {
                  list($user,$value) = split(' ', $myentry['acl'][$j], 2);
                  $user = trim($user);
                  $value = trim($value);
               }
	       $perms = $options;
               if ($value) $perms[$value] = 'selected';
               print "<td><input type=\"text\" name=\"user_$j\" size=25 maxlength=80 value=\"$user\"></td>\n";
               print "<td><select name=\"permission_$j\" size=\"1\">\n";
               for ($r=0; $r<$options['count']; $r++) {
                  $optname = $options[$r];
                  $selected = $perms[$optname];
                  print "<option $selected> $optname </option>\n";
               }
               print "</select></td>\n";
            } else {
               $value = trim($myentry[$attr][$j]);
               print "<td><input type=\"text\" name=\"".$attr."_".$j."\" size=25 maxlength=80 value=\"$value\"></td><td></td>\n";
            }
         } else {
            if ($value) print "<td> $value </td> <td></td>";
               else print "(not set)";
         }
         print "<td>".(comment($attr))."</td></tr>\n";
      }
   }  
}   

print "</table>\n";
print "<table cellspacing=\"20\" cellpadding=\"0\">\n";
print "<tr><td></td><td><input type=\"image\" src=\"../pics/button_ok.png\" name=\"apply\" value=\"Apply\"></td>\n";
print "<td><a href=\"index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
print "</table>\n";
print "</form>\n";
print "</center></td></tr></table>\n";

}

if ($errors) {
   print("<TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>");
   print("</TD></TR>\n");
   print("</TABLE>\n");
}

print("</TABLE>\n");

Foot(); 
?>
