<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("sharedfolder/");
  Head();
?>

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>
<TR><TD HEIGHT=20></TD></TR>
<TR><TD><center><H1> Manage Shared Folders </H1></center></TD></TR>

<?
if (isset($HTTP_GET_VARS['alphaselect'])) $alphaselect = $HTTP_GET_VARS['alphaselect'];
   else $alphaselect = "[A-F]" ;

$errors = array();

// check user authentication
if (!($uid = $_SERVER["PHP_AUTH_USER"]) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid)))
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "admin" && $group != "maintainer")
   array_push($errors, "Error: You don't have Permissions to access this Menue");

$myself = $_SERVER['PHP_SELF'];

if (isset($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (isset($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

//JMD: use myldap_connect
if (!$errors && !($link = myldap_connect($ldap_server,$ldap_port)) || !ldap_bind($link))
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($link));

switch ($alphaselect) {
   case "[A-F]":
      $searchFilter = "(&(|(cn=F*)(cn=E*)(cn=D*)(cn=C*)(cn=B*)(cn=A*))(objectClass=kolabSharedFolder))";
      break;
   case "[G-L]":
      $searchFilter = "(&(|(cn=G*)(cn=H*)(cn=I*)(cn=J*)(cn=K*)(cn=L*))(objectClass=kolabSharedFolder))";
      break;
   case "[M-S]":
      $searchFilter = "(&(|(cn=M*)(cn=N*)(cn=O*)(cn=P*)(cn=Q*)(cn=R*)(cn=S*))(objectClass=kolabSharedFolder))";
      break;
   case "[T-Z]":
      $searchFilter = "(&(|(cn=T*)(cn=U*)(cn=V*)(cn=W*)(cn=X*)(cn=Y*)(cn=Z*))(objectClass=kolabSharedFolder))";
      break;
   default:
      $searchFilter = "(objectClass=kolabSharedFolder)";
}

if (!$errors) {
   $result = ldap_search($link,$_SESSION['base_dn'],$searchFilter);
   if ($result) {
      print("<tr><td><form method=\"POST\" action=\"$myself\"><center><h2>\n");
      $text="[A-F]";
      print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>\n");
      $text="[G-L]";
      print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>\n");
      $text="[M-S]";
      print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>\n");
      $text="[T-Z]";
      print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>\n");
      $text="[all]";
      print("<a href=\"$myself?alphaselect=$text\">&nbsp;&nbsp;$text&nbsp;&nbsp;</a>\n");
      print("</h2></form></center></td></tr>\n");
      print("<TR><TD HEIGHT=20></TD></TR>\n");

      print("<TD ALIGN=center>\n");
      print("<TABLE WIDTH=95% BORDER=1 CELLSPACING=0 bgcolor=\"#dcdcdc\" CELLPADDING=3 nosave>\n");
      ldap_sort($link,$result,'cn');
      $entry = ldap_first_entry($link, $result);
      if (!$entry) {
         print("<tr><td align=center> No shared folders in the category $alphaselect</td></tr>\n");
      } else {
         print("<thead><td><b>Folder Name</b></td><td><b> Actions </b></td></thead>\n");
         while ($entry) {
            // $dn = urlencode($resultEntries[$i]["dn"]);
            $dn = ldap_get_dn($link, $entry);
            $attrs = ldap_get_attributes($link,$entry);
            $cn = utf8_decode($attrs['cn'][0]);
	    printf("<tr align=center><td>%s</td><td>
                   <a href=\"create_sharedfolder.php?action=modify&dn=%s\"> [Modify]</a>
                   <a href=\"create_sharedfolder.php?action=delete&dn=%s\"> [Delete]</a>
		   </td></tr>\n",$cn,$dn,$dn);
            $entry = ldap_next_entry($link,$entry);
         }
      }
      ldap_free_result($result);
   } 
   ldap_close($link);
   print "</table>\n";
} 

if ($errors) {
   print("<TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>");
   print("</TD></TR>\n");
   print("</TABLE>\n");
}

Foot();
?>

