<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("user/");
  Head();
?>

<table width="100%" cellspacing="8" cellpadding="8" border="0" summary="main contents">
<tr><td><center><h1> Manage Email Users </h1></center></td></tr>
<?

$utf8 = array ( 'cn', 'sn' );

$errors = array();

// check user authentication 
if (!($uid = $_SERVER["PHP_AUTH_USER"]) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid))) 
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "maintainer" && $group != "admin") 
   array_push($errors, "Error: You don't have Permissions to access this Menue");

// read selector for register display
if (isset($HTTP_GET_VARS['alphaselect'])) $alphaselect = $HTTP_GET_VARS['alphaselect'];
   else $alphaselect = "[A-F]";

if (isset($_SESSION['base_dn'])) $base_dn = $_SESSION['base_dn'];
   else $base_dn = 'k=kolab' ;

$myself = $_SERVER['PHP_SELF'];

if (isset($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (isset($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

//JMD: use myldap_connect
if (!$errors && !($link = myldap_connect($ldap_server,$ldap_port)) || !ldap_bind($link,$bind_dn,$_SERVER["PHP_AUTH_PW"])) 
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($link));   

//JMD: modify search filter so it doesn't search on '(email=*)' because
//     otherwise it doesn't show regular posix users. Also I had to
//     replace "(uid=*)" by "(!(uid=nobody))" since we don't want this
//     user
switch ($alphaselect) {
   case "[A-F]":
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=nobody))(|(sn=F*)(sn=E*)(sn=D*)(sn=C*)(sn=B*)(sn=A*)";
      $filter = $filter."(sn=f*)(sn=e*)(sn=d*)(sn=c*)(sn=b*)(sn=a*)";
      if (in_array('sn', $utf8)) $filter = $filter."(sn=".utf8_encode("")."*)(sn=".utf8_encode("")."*)";
      $filter = $filter."))";
      break;
   case "[G-L]":
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=nobody))(|(sn=G*)(sn=H*)(sn=I*)(sn=J*)(sn=K*)(sn=L*)";
      $filter = $filter."(sn=g*)(sn=h*)(sn=i*)(sn=j*)(sn=k*)(sn=l*)))";
      break;
   case "[M-S]":
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=nobody))(|(sn=M*)(sn=N*)(sn=O*)(sn=P*)(sn=Q*)(sn=R*)(sn=S*)";
      $filter = $filter."(sn=m*)(sn=n*)(sn=o*)(sn=p*)(sn=q*)(sn=r*)(sn=s*)";
      if (in_array('sn', $utf8)) $filter = $filter."(sn=".utf8_encode("")."*)(sn=".utf8_encode("")."*)".
                                                   "(sn=".utf8_encode("")."*)(sn=".utf8_encode("")."*)";   
      $filter = $filter."))";
      break;
   case "[T-Z]":
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=nobody))(|(sn=T*)(sn=U*)(sn=V*)(sn=W*)(sn=X*)(sn=Y*)(sn=Z*)";
      $filter = $filter."(sn=t*)(sn=u*)(sn=v*)(sn=w*)(sn=x*)(sn=y*)(sn=z*)))";
      break;
   default: 
      $filter = "(&(cn=*)(objectclass=inetOrgPerson)(!(uid=nobody))(sn=*))";
      break;
}

if (!$errors) {
$result = ldap_search($link, $base_dn, $filter);
if ($result) {
   print("<tr><td><center><form method=\"POST\" action=\"$myself\">\n<h2>\n");
   $text = "[A-F]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>");
   $text = "[G-L]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>");
   $text="[M-S]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>");
   $text="[T-Z]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;$text&nbsp;</a>");
   $text="[all]";
   print("<a href=\"$myself?alphaselect=$text\">&nbsp;&nbsp;$text&nbsp;&nbsp;</a>\n");
   print("</h2></form></center></td></tr>");
   print("<tr><td height=\"20\"></td></tr>\n");

   print("<tr><td>\n");
   print("<table width=\"95%\" border=\"1\" cellspacing=\"0\"
cellpadding=\"3\" bgcolor=\"#dcdcdc\" 
          summary=\"none\" nosave>\n");

   ldap_sort($link,$result,'sn');
   $entry = ldap_first_entry($link, $result);
   if (!$entry) { 
      print("<tr><td> (No users in the category $alphaselect) </td></tr>\n");
   } else {
      printf("<thead><td><b> Name </b></td><td><b> E-Mail </b></td><td><b> Action </b></td></thead>\n");
      while ($entry) {   
         $dn = ldap_get_dn($link,$entry);
         $attrs = ldap_get_attributes($link, $entry);
         $deleted = $attrs['kolabDeleteflag'][0];
         $userid = $attrs['uid'][0];
         $mail = $attrs['mail'][0];
         $sn = $attrs['sn'][0];
         if (in_array('sn', $utf8)) $sn = utf8_decode($sn);
         $cn = $attrs['cn'][0];
         if (in_array('cn', $utf8)) $cn = utf8_decode($cn);
         $a = strlen($sn);
         $b = strlen($cn);
         //JMD: get rid of the extra space and deal with the possibility
         //     that cn might not contain last name, or that the
         //     cn contains last+first
         if(strpos($cn,$sn)>0) {
            $fn = rtrim(substr($cn, 0, $b - $a));
         } else if(strpos($cn,$sn)===0) {
	    $fn = ltrim(substr($cn, $a-$b, $b)); 
         } else {
            $fn = rtrim($cn);
         }
	 //JMD: check if entry has kolabInetOrgPerson attributes
	 $iskolab=0;
	 for($i=0;$i<$attrs['objectClass']['count'];$i++) {
            if($attrs['objectClass'][$i]=='kolabInetOrgPerson') $iskolab=1;
	 }

         $gid = uid2group($userid);
	 //JMD
	 if($cn=='Administrator') { $gid="next"; }
	 if($cn=='NextFreeUnixId') { $gid="next"; }
	 if(strpos($cn,'$')) { $gid="next"; }
         if ($gid == "user") {
            $userid = urlencode($userid);
            $dn = urlencode($dn);
            if ($deleted != "TRUE") {
	      //JMD
              printf("<tr><td> %s, %s </td><td> <a href=\"mailto:%s\">%s</a></td>",$sn, $fn, $mail,$mail);
	      printf("<td> <a href=\"create_user.php?action=modify&dn=%s\">",$dn);
	      if($iskolab) {
 	         printf("[Modify]</a>");
                 printf("<a href=\"create_user.php?action=delete&dn=%s\">[Delete]</a>",$dn);
	      } else {
 	         printf("[Modify / Convert to Kolab]</a>");
	      }
	      printf(" </td></tr>\n");
            } else {
              printf("<tr><td> %s, %s </td>
                          <td> <a href=\"mailto:%s\">%s</a></td>
                          <td> <b> User Deleted, awaiting cleanup... </b></td>
                     </tr>\n", $sn, $fn, $mail, $mail, $dn, $dn);
            }
         }
         $entry = ldap_next_entry($link, $entry);
      } 
      ldap_free_result($result);
   }
   ldap_close($link);
} else array_push($errors, "Communication Error: ldap server did not answer query for user information");

}
print("</table></td></tr>\n");

if ($errors) {
   print("<table width=\"100%\" cellspacing=\"20\" cellpadding=\"0\" border=\"0\" summary=\"none\">\n");
   print("<tr><td></td></tr>\n");
   print("<tr><td><h3> There were Errors : </h3></td></tr>\n");
   print("<tr><td>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>"); 
   print("</td></tr>\n");
   print("</table>\n");
}

Foot(); 
?>
