<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("user/vacation");
  Head();
?>

<TABLE border=0 WIDTH="100%" CELLSPACING=10 CELLPADDING=10>
<TR><TD HEIGHT=20></TD></TR>
<TR><TD><center><H1> My User Vacation Notification Setup</H1></center></TD></TR>

<?

include("../include/sieve-php.lib");
include("../include/sieve-functions.php");

$errors = array();

// check user authentication 
if (!($uid = $_SERVER["PHP_AUTH_USER"]) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid))) 
   array_push($errors, "Internal Error: could not get UID Authentication Information");

if (!($passwd = $_SERVER["PHP_AUTH_PW"]))
   array_push($errors, "Internal Error: could not get Password Authentication Information");
   
if (!$errors && $group != "user" ) 
   array_push($errors, "Error: You don't have Permissions to access this Menue");

// get user's email addresses
if (isset($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (isset($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

if (isset($_SESSION['base_dn'])) $base_dn = $_SESSION['base_dn'];
   else $base_dn = 'k=kolab' ;

//JMD: use myldap_connect
if (!$errors && !($link = myldap_connect($ldap_server,$ldap_port)) || !ldap_bind($link,$bind_dn,$_SERVER["PHP_AUTH_PW"]))
   array_push($errors, "Communication Error: could not query ldap://$ldap_server:$ldap_port ".ldap_error($link));

// get list of email aliases for user
$filter = "(uid=".$uid.")";
$address_list = "\"$uid\", ";
if (($result = ldap_search($link, $base_dn, $filter)) &&
    ($entry = ldap_first_entry($link,$result)) &&
    ($ldap_object = ldap_get_attributes($link,$entry))) {
    for ($count = 0 ; $count < $ldap_object['alias']['count']; $count++) {
       $address_list .= "\"".$ldap_object['alias'][$count]."\", ";
    }
    $address_list = rtrim($address_list); // get rid of whitespace
    $address_list = rtrim($address_list,','); // get rid of extra comma
    ldap_free_result($result);
}
ldap_close($link);

// read selector for register display
if (isset($HTTP_GET_VARS['action'])) $action = $HTTP_GET_VARS['action'];
   else $action = "start";

if (isset($HTTP_GET_VARS['day'])) $day = $HTTP_GET_VARS['day'];
   else $day = 1;

if (isset($HTTP_GET_VARS['month'])) $month = $HTTP_GET_VARS['month'];
   else $month = 1;

if (isset($HTTP_GET_VARS['year'])) $year = $HTTP_GET_VARS['year'];
   else $year = 2002;

if (isset($HTTP_GET_VARS['vacnotify'])) $vacnotify = $HTTP_GET_VARS['vacnotify'];
   else $vacnotify = 7;

if (isset($HTTP_GET_VARS['vacmsg'])) $vacmsg = $HTTP_GET_VARS['vacmsg'];
   else $vacmsg = "";

$myself = $_SERVER['PHP_SELF'];

if (isset($_SESSION['sieve_server'])) $sieve_server = $_SESSION['sieve_server'];
   else $sieve_server = '127.0.0.1';

if (isset($_SESSION['sieve_port'])) $sieve_port = $_SESSION['sieve_port'];
   else $sieve_port = 2000;

$sieve=new sieve($sieve_server, $sieve_port, $uid, $passwd, $uid);

// this is the name KDE client stores - so we can also change the setting from KDE client
$scriptname = "kmail-vacation.siv";


if (!($sieve->sieve_login()))
   array_push($errors,"Could not log on to timsieved daemon on your IMAP server sieve://$sieve_server:$sieve_port");

if (!$errors) {
   // on start show if sieve script is present or not
   if ($sieve->sieve_listscripts())  {
      if ($action == "start") 
         print("<TR><TD><center>vacation notifiy or email forward already active!</center></TD></TR>");
      $sieveactive = TRUE;
   } else {
      if ($action == "start") 
//         print("<TR><TD><center>Currently neither a vacation or forward setting activated</center></TD></TR>");
      $sieveactive = FALSE;
   }
   
   switch ($action) {
       case "create":
          if ($sieveactive == TRUE) {
             delete_script ($scriptname);
          }
          $newscript = "require \"vacation\";";
	  $newscript .= "\nvacation :days ".$vacnotify;
	  // JMD: don't use address_list, if there's no @domain part
	  // it crashes Apache/PHP =(
	  //$newscript .= "\n\t :addresses     [" .$address_list;
	  // $newscript .= "]\n";
	  $newscript .= "\n";
	  
          $vacmsg=str_replace("\'", "\\\'", $vacmsg);
          $vacmsg=str_replace("\\", "\\\\", $vacmsg);
          $vacmsg=str_replace("\"", "\\\"", $vacmsg);
         
	  $vacmsg_utf8=$vacmsg;
         
	  $vacmsg=str_replace('\"','&quot;',$vacmsg);
          $vacmsg=str_replace("\'","&acute;",$vacmsg);
          $vacmsg=stripslashes($vacmsg);
          $vacmsg_utf8=str_replace('\"',"''",$vacmsg_utf8);
          $vacmsg_utf8=str_replace("\'","'",$vacmsg_utf8);
          $vacmsg_utf8=utf8_encode($vacmsg_utf8);

          $newscript .= " \"".$vacmsg_utf8."\";\n";
	  
          upload_script ($newscript,$scriptname);
	  
    if (!($sieve->sieve_setactivescript($scriptname)))
      array_push($errors,"Could not upload and activate directive on your IMAP server!");

    $vacmsg=str_replace('\"','&quot;',$vacmsg); 
    $vacmsg=str_replace("\'","&acute;",$vacmsg); 
    $vacmsg=stripslashes($vacmsg);

    print "<tr><td>People sending you E-Mail will be notified every $vacnotify days with the following message:</td></tr>\n";
    print "<tr><td align=\"left\"><pre>$vacmsg</pre></center></td></tr></table>\n";
    print "<CENTER><TABLE WIDTH=\"10%%\" CELLSPACING=0 CELLPADDING=0 BORDER=0>\n";
    print "<TR><TD HEIGHT=20></TD></TR>\n";
    print "<TR><TD><form action=\"$myself\" method=\"GET\">\n";
    print "<td><a href=\"../index.php\"> <img src=\"../pics/button_ok.png\" alt=\"OK\"></a></td></tr>\n";
    print "</table></form></center>\n";
    print "</td></tr>\n";
    break;
  case "delete":
    if ($sieveactive == TRUE) {
      delete_script ($scriptname);
	     print "<tr><td><center>Vacation notification or email forwarding
setting successfully deleteted</center></td></tr></table>\n";
    }
    else {
      print "<tr><td><center>No vacation or forward directive on server found to be deleted!</center></td></tr></table>\n";
    }
    print "<center><table width=\"10%%\" cellspacing=0 cellpadding=0 border=0>\n";
    print "<TR><TD height=20></TD></TR>\n";
    print "<TR><TD><form action=\"$myself\" method=\"GET\">\n";
    print "<td><a href=\"$myself\"> <img src=\"../pics/button_ok.png\" alt=\"OK\"></a></td></tr>\n";
    print "<input type=\"hidden\" name=\"action\" value=\"start\">\n";
    print "</table></form></center>\n";
    print "</td></tr>\n";
    break;
  default:
//          print("\naction: $action.\n\n");
    if ($sieve->sieve_listscripts()) {
      $action = "firstdelete"; } 
    else {
	     $action = "firstcreate"; 
    }
    print "<tr><td><center><form action=\"$myself\" method=\"GET\">\n";
    print "<table border=0 cellspacing=0 cellpadding=3>\n";
    if ($action == "firstcreate") {
	     $today = getdate();
	     $day = $today['mday'];
	     $month = $today['mon'];
	     $year = $today['year'];
	     $day = $day + 7;
	     if ($day > 31) {
	        $day = $day -31;
		$month = $month +1;
             }
	     if ($month > 12) {
	        $month = $month -12;
		$year = $year +1;
     }
     $vacmsg = "I will be out of the office until ".$day.".".$month.". ".$year.". Please sent urgent enquiries to";
	  
/*             print "<td align=\"right\"><select name=\"vacnotify\">";
             for ($i=1; $i<=10; $i++) {
	        if ($i == 7) {
                   print "<option selected>$i</option>";
		} else {
                   print "<option>$i</option>";
		}
             }
             print "</select></td>\n";
*/
print "<tr><td> Please customize the vacation notification text according to your requirements:
      </td></tr>\n";

             print "<tr><td><textarea name=\"vacmsg\" cols=\"79\" rows=\"18\">

I'm on vacation and will not be reading my mail for a while.
Your mail will be dealt with when I return.

</textarea></td></tr>\n";

print "<tr><td align=\"left\">Senders will be notified at most 
once within a <select name=\"vacnotify\">";
             for ($i=1; $i<=31; $i++) {
                if ($i == 7) {
                   print "<option selected>$i</option>";
                } else {
                   print "<option>$i</option>";
                }
             }
             print "</select> day period.</td>\n";

             print "</table></CENTER>\n";

             print "<tr><td><center><table width=\"60%\" cellspacing=10 cellpadding=10><tr>\n";
	     print "<TR><TD HEIGHT=20></TD></TR>\n";
             print "<input type=\"image\" src=\"../pics/button_ok.png\" name=\"create\" alt=\"create\" value=\"Apply\">\n";
	     print "<input type=\"hidden\" name=\"action\" value=\"create\">\n";
             print "<a href=\"../index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
             print "</table></CENTER>\n";
          } else {
	     // delete the script on the server before setting a new one...
	     print "<tr><td>Please delete the currently active your vacation
notification or email forward setting by pressing the OK button before
proceeding!
</td></tr>\n";
	     print "</table>\n";
             print "<TABLE WIDTH=\"30%%\" CELLSPACING=0 CELLPADDING=0 BORDER=0>\n";
	     print "<TR><TD HEIGHT=20></TD></TR>\n";
	     print "<tr><td><input type=\"image\" src=\"../pics/button_ok.png\" name=\"delete\" value=\"Apply\"></td>\n";
	     print "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
	     print "<td><a href=\"../index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
	  }
          // close the centered table form

          print "</table></form></center>\n";
          print "</td></tr>\n";
   }
   $sieve->sieve_logout();
}

if ($errors) {
   print "<tr><td><table width=\"100%\" cellspacing=20 cellpadding=0 border=0>\n";
   print "<tr><td height=20></td></tr>\n";
   print "<tr><td><h3> There were Errors : </h3></td></tr>\n";
   print "<tr><td>\n";
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>"); 
   print "</td></tr>\n";
   print "</table>\n";
   print "</td></tr>\n";
}
?>

</TABLE>

<?php
Foot(); 
?>
