<?php
/*
 (c) 2001 Dan Ellis <danellis@rushmore.com>
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de> 
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/

function upload_script ($newscript,$scriptname) {
        global $sieve;

// DEBUG:
//        print "<pre>Sending the script...";
//        print $newscript;
//        print "</pre>";

        if($sieve->sieve_sendscript($scriptname, stripslashes($newscript))) {
                return true;
//                print "Your rules have been successfully updated.<br />";
        } else {
                print "Unable to load script to server.  See server response below:<br />
                <blockquote><font color=#aa0000>";
                if(is_array($sieve->error_raw)) {
                        foreach($sieve->error_raw as $error_raw)
                        print $error_raw."<br>";
                } else {
                        print $sieve->error_raw."<br>";
                }
                print "</font></blockquote>";
                return false;
        }
}

function delete_script ($scriptname) {
        global $sieve;

        if($sieve->sieve_deletescript($scriptname)) {
                return true;
        } else {
                print 'Unable to delete script from server. See server response below:<br />
                <blockquote><font color="red">';
                if(is_array($sieve->error_raw)) {
                        foreach($sieve->error_raw as $error_raw)
                                print $error_raw."<br>";
                } else {
                        print $sieve->error_raw."<br>";
                }
        print "</font></blockquote>";
        return false;
        }
}
?>
