<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("server/");
  Head();
?>

<TABLE WIDTH="80%" CELLSPACING=0 CELLPADDING=0 BORDER=0>
<TR><TD HEIGHT=20></TD></TR>
<TR><TD><center><H1> Server Settings </H1></center></TD></TR>
<TR><TD><CENTER>

<?
function debug ($a) {
//      print "debug: $a<br>\n";
}

debug("debug is on");

$errors = array();
   
$hostname = "";
$mydomain = ""; 
$change = "";

// print_r($HTTP_GET_VARS);

if (isset($HTTP_GET_VARS['change'])) $change = trim(urldecode($HTTP_GET_VARS['change']));
if (isset($HTTP_GET_VARS['hostname'])) $hostname = trim(urldecode($HTTP_GET_VARS['hostname']));
if (isset($HTTP_GET_VARS['mydomain'])) $mydomain = trim(urldecode($HTTP_GET_VARS['mydomain']));
if (!($uid = $_SERVER["PHP_AUTH_USER"]) || 
    !($password=$_SERVER['PHP_AUTH_PW']) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid))) 
   array_push($errors, "Internal Error: could not read credentials");

if ($group != "admin") array_push($errors, "Error: invalid permissions");

if (isset($_SESSION['ldap_server'])) $ldap_server=$_SESSION['ldap_server'];
   else $ldap_server = "127.0.0.1";
if (isset($_SESSION['ldap_port'])) $ldap_port=$_SESSION['ldap_port'];
   else $ldap_port = 389;
if (isset($_SESSION['base_dn'])) $base_dn = $_SESSION['base_dn'];
   else $base_dn = 'k=kolab' ;

$myself=$_SERVER['PHP_SELF'];

//JMD: use myldap_connect
if (!($link=myldap_connect($ldap_server,$ldap_port)) ||
    !ldap_bind($link, $bind_dn, $password) ) {
   array_push($errors, "LDAP Error: could not connect to ldap://$ldap_server:$ldap_port ".ldap_error($link));
}

if (!$errors) {

   switch ($change) {
      case  "change":
         $attrs = array();
         if ($hostname) $attrs['kolabHost'][0] = $hostname; 
         if ($mydomain) {
             if (($result = ldap_read($link, "k=kolab,".$base_dn, "(objectclass=*)")) &&
                 ($entry = ldap_first_entry($link,$result)) &&
                 ($dattrs = ldap_get_attributes($link,$entry))) {
                $domain = $dattrs['postfix-mydomain'][0];
                ldap_free_result($result);
             }
             $attrs['postfix-mydomain'][0] = $mydomain;
             # now we go through the whole LDAP tree and change the email domain
             $result = ldap_search($link, $base_dn, "(|(mail=*)(alias=*))");
             if ($result) {
              $entry = ldap_first_entry($link, $result);
              if ($entry) {
                   $dn = ldap_get_dn($link,$entry);
                 do {
                    $newattrs = array();
                      $person = ldap_get_attributes($link,$entry);
                    if (!empty($person['mail']) && stristr($person['mail'][0], $domain)) {
                         $newattrs['mail'] =
                          substr($person['mail'][0], 0, strpos($person['mail'][0],'@'))."@".$mydomain;
                      }
                      if (!empty($person['alias'])) {
                      for ($i=0; $i < $person['alias']['count']; $i++) {
                         if (!empty($person['alias'][$i]) &&
                             stristr($person['alias'][$i], $domain)) {
                            $newattrs['alias'][$i] =
                               substr($person['alias'][$i], 0, strpos($person['alias'][$i],'@'))."@".$mydomain;
                         }
                        }
                      }
                      if (!ldap_modify($link, $dn, $newattrs))
                         array_push($errors, "LDAP Error: could not modify object $dn ".ldap_error($link));
                      $entry = ldap_next_entry($link, $entry);
                   } while ($entry);
                }
                ldap_free_result($result);
             }
         }

         if (!ldap_modify ($link,"k=kolab,".$_SESSION['base_dn'],$attrs)) 
            array_push($errors, "LDAP Error: failed to modify kolab config object ".ldap_error($link));
         break;
   }
   
   if (($result = ldap_read($link, "k=kolab,".$_SESSION['base_dn'], "(objectclass=*)")) &&
       ($entry = ldap_first_entry($link, $result)) &&
       ($attrs = ldap_get_attributes($link, $entry))) {
      $hostname = $attrs['kolabHost'][0]; 
      $mydomain = $attrs['postfix-mydomain'][0];
      ldap_free_result($result);
   } else array_push($errors, "LDAP Error: could not kolab configuration object ".ldap_error($link));

   ldap_close($link);

   print("<form method=\"GET\" action=\"$myself\">\n");
   print("<table cellspacing=10 cellpadding=10>\n");
   print("<tr><th> Attribute </th><th> Value </th><th> Comment </th></tr>\n");
   print("<tr><td> Hostname</td>\n");
   print("<td><input type=\"text\" name=\"hostname\" size=25 maxlength=80 value=\"$hostname\"></td>\n");
   print("<td> This hostname will be given by the Mail Server and the IMAP Server to the clients </td></tr>\n");
   print("<tr><td> E-Mail Domain</td>\n");
   print("<td><input type=\"text\" name=\"mydomain\" size=25 maxlength=80 value=\"$mydomain\"></td>\n");
   print("<td> Be advised that renaming the E-Mail Domain affects all E-Mail Addresses! </td></tr>\n");
   print("</table>\n");
   print("<input type=\"hidden\" name=\"change\" value=\"change\">\n");

   print("</center></td></tr>\n");   
   print("<tr><td><center><table width=\"40%\" cellspacing=10 cellpadding=10><tr>\n"); 
   printf("<td><input type=\"image\" src=\"../pics/button_ok.png\" name=\"change\"></td>");
   printf("<td><a href=\"../index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n");
   printf("</center></table></form>\n");
}

print("</center></td></tr></table>\n");

if ($errors) {
   print("<TABLE WIDTH=\"80%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>");
   print("</TD></TR>\n");
   print("</TABLE>\n");
}

Foot();  
?>
