<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("user/create_user.php?action=".$HTTP_GET_VARS['action']);
  Head();
  include("../include/checks.php");
?>

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>

<?
function debug ($a) {
//   print "debug: $a<br>\n";
}

debug("debug is on");

$errors = array();
$valid_actions = array('save','firstsave','modify','create','delete','kill');

if (!empty($HTTP_GET_VARS['action']) && 
    in_array($HTTP_GET_VARS['action'],$valid_actions)) $action = trim(urldecode($HTTP_GET_VARS['action']));
   else array_push($errors, "Error: need valid action to proceed");

$dn="";
if (!empty($HTTP_GET_VARS['dn'])) $dn = trim(urldecode($HTTP_GET_VARS['dn']));

if (!($uid = $_SERVER['PHP_AUTH_USER']) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid)))
   array_push($errors, "Internal Error: could not get Authentication Information");

if (!$errors && $group != "maintainer" && $group != "admin" && 
    !($group == "user" && $dn == $bind_dn)) 
   array_push($errors, "Error: You don't have the required Permissions"); 

debug("givenuid=$uid, bind_dn=$bind_dn, dn='$dn', group=$group");

$myself = $_SERVER['PHP_SELF'];

if (!empty($_SESSION['ldap_server'])) $ldap_server = $_SESSION['ldap_server'];
   else $ldap_server = '127.0.0.1';

if (!empty($_SESSION['ldap_port'])) $ldap_port = $_SESSION['ldap_port'];
   else $ldap_port = 389;

$attributes = array( 'title', 'cn', 'sn', 'uid', 'mail', 'o',
                     'ou', 'roomNumber', 'street', 'postOfficeBox',
                     'postalCode', 'l', 'c', 'telephoneNumber',
                     'facsimileTelephoneNumber', 'userPassword' );

$utf8 = array ( 'cn', 'title', 'o', 'ou', 'roomNumber', 'street', 'sn',
                'postOfficeBox', 'postalCode', 'l', 'c', 'telephoneNumber',
                'facsimileTelephoneNumber' );
function to_utf8 ($a)
{
   global $utf8;
   global $attributes;
   $utf8_ecnoded = true;
   foreach ($attributes as $attr) {
      if (!in_array($attr,$utf8) || empty($a[$attr])) continue;
      if (is_array($a[$attr])) {
         $index = 0;
         while (!empty($a[$attr][$index])) {
            $a[$attr][$index] = utf8_encode($a[$attr][$index]);
            $index++;
         }
      } elseif (!empty($a[$attr])) $a[$attr] = utf8_encode($a[$attr]);
   }
   return $a;
}

function from_utf8 ($a)
{
   global $utf8;
   global $attributes;
   foreach ($attributes as $attr) {
      if (!in_array($attr,$utf8) || empty($a[$attr])) continue;
      if (is_array($a[$attr])) {
         $index = 0;
         while (!empty($a[$attr][$index])) {
            $a[$attr][$index] = utf8_decode($a[$attr][$index]);
            $index++;
         }
      } elseif (!empty($a[$attr])) $a[$attr] = utf8_decode($a[$attr]);
   }
   return $a;
}

function fill_up($a)
{
   global $attributes;
   foreach ($attributes as $attr) {
//      if ($attr == 'uid' || $attr == 'mail') continue;
//JMD: this prevented changes in e-mail...
      if ($attr == 'uid') continue;
      if (empty($a[$attr])) $a[$attr] = array();
   }
   return $a;
}

function fill_up2 ($a)
{
   global $attributes;
   foreach ($attributes as $attr) {
      if ($attr == 'uid' || $attr == 'mail') continue;
      if (empty($a[$attr])) $a[$attr] = array(0 => "", 'count' => 1);
   }
   return $a;
}


$beautify = array (
      'c' => 'Country', 'l' => 'City', 'street' => 'Street Address', 'telephoneNumber' => 'Telephone Number',
      'postOfficeBox' => 'Postbox', 'postalCode' => 'Postal Code', 'ou' => 'Organizational Unit',
      'o' => 'Organization', 'roomNumber' => 'Room Number', 'title' => 'Title', 'cn' => 'Name',
      'sn' => 'Surname', 'facsimileTelephoneNumber' => 'Fax Number', 'mail' => 'Primary E-Mail Address',
      'alias' => 'E-Mail Alias', 
      'uid' => 'Unique UserID', 
      'cyrus-userquota' => 'Mailbox Size Limit',
      'userPassword' => 'Password', 'firstname' => 'First Name', 'lastname' => 'Last Name');

function dobeautify ($a)
{
   global $beautify;
   if (array_key_exists($a, $beautify)) return $beautify[$a];
   return $a;
}

if ($action == "create" || $action == "firstsave" ) {
  $comment_uid_0 = 'Required, cannot be modified after user is created' ; }
else {
  $comment_uid_0 = 'Cannot be modified' ;
}
if ($action == "create" || $action == "firstsave" ) {
  $comment_mail_0 = 'Optional, default is user@domain' ; }
else {
  $comment_mail_0 = '' ;
}
if ($group == "admin" || $group == "maintainer") {
  $comment_alias_0 = 'one alias per line' ; }
else {
  $comment_alias_0 = '(Can be modified by system administrators only)' ;
}

//JMD: use lastname, not sn_0!
$comment = array(
   'firstname' => 'Required', 'lastname' => 'Required',
   'password_0' => 'Required', 'password_1' => 'Required',
   'uid_0' => $comment_uid_0,
   'mail_0' => $comment_mail_0,
   'visible' => 'check here to make this users address <br> visible in the address book',
   'alias_0' => $comment_alias_0);


function comment ($a)
{
   global $comment;
   if (array_key_exists($a, $comment)) return $comment[$a];
   return '';
}

$blacklist = array('cn', 'sn', 'uid', 'mail', 'userPassword');

function black ($a)
{
   global $blacklist;
   return in_array($a,$blacklist);
}

$noshow = array('objectClass','cn','sn', 'mail', 'userPassword', 'uid');


function noshow ($a)
{
   global $noshow;
   return in_array($a, $noshow);
}


$firstname = "";
$lastname = "";
$password_0 = "";
$password_1 = "";
$uid_0 = "";
$mail_0 = "";
$domain = "";
$domain_dn = "";
$visible = true;
if (strstr($dn, "cn=internal")) $visible = false; 

$missing_input = 0;

function missing_input ()
{
   global $missing_input;
   global $errors;
   
   if (!$missing_input) {
      $missing_input++;
      array_push($errors, "Error: Input required");
   }
}

//JMD: add user, otherwise when we modify the entry, it's never
//     unique, since we already have that entry!
function is_unique ($a,$b,$user="",$key="uid")
{
   global $link;
   if(!$user) {
      $filter="(".$a."=".$b.")";
   } else {
      $filter="(&($a=$b)(!($key=$user)))";
   }
   if (($result = ldap_search($link,$_SESSION['base_dn'],$filter)) &&
       (ldap_count_entries($link,$result) <= 0))
      return TRUE;
   return FALSE;
}

//JMD: check valid email
function is_valid_email($email) {
  global $domain;
  //echo "<br>Email to check: $email</br>";
  //JMD: This include should define an array, 'virtual', which is a list
  //     of valid virtual domains. Don't include the local domain,
  //     since we add it automatically
  $virtual=array();
  @include("../include/virtual.php");

  array_push($virtual, $domain);

  foreach($virtual as $key => $value) {
     //echo "<br>Checking $value";	
     if(preg_match("/.*@\b".$value."\b$/",$email)) {
        //echo "<br>Found! $value";
	$domainmatch=1;
     }
  }

  if(!$domainmatch) return(false);
  
  if(!email_address_ok($email,$domain)) {
	return(false);
  } else {
	return(true);  
  }
}


//JMD: display message and array
function debug2($msg,$arr) {
   echo "<pre>$msg<br>";
   print_r($arr);
   echo "</pre><hr>";
}

//JMD: New Kolab 2 schema
$oc0='inetOrgPerson';
$oc1='top';
$oc2='kolabInetOrgPerson';
$oc3='kolabExtendedSchema';
$ldap_object = array('objectClass' => array(0=>$oc0, 1=>$oc1, 2=>$oc2, 3=>$oc3));
//debug2("objectClass",$ldap_object);

//JMD: use myldap_connect
if (!$errors && (!($link = myldap_connect($ldap_server,$ldap_port)) || 
    !@ldap_bind($link, $bind_dn, $_SERVER["PHP_AUTH_PW"])))
   array_push($errors, "Communication Error: could bind to ldap://$ldap_server:$ldap_port ".ldap_error($link));
//JMD: it we can't bind, most likely the user just changed passwords
if ($errors) {
   echo "<H1>Please close all your browser windows, and log in again!</H1>";
   exit;
} else {
   // ldap_set_option($link, LDAP_OPT_PROTOCOL_VERSION, 3);
   //JMD add k=kolab otherwise it doesn't work
   if (($result = ldap_read($link, "k=kolab,".$_SESSION['base_dn'], "(objectclass=*)")) &&
       ($entry = ldap_first_entry($link,$result)) &&
       ($dattrs = ldap_get_attributes($link,$entry))) {

      $domain = $dattrs['postfix-mydomain'][0];
      $dcs = array_reverse(explode('.', $domain));
      $domain_dn = $_SESSION['base_dn'];
      foreach ($dcs as $dc) $domain_dn = "dc=$dc,".$domain_dn;

   //JMD 
   //echo "<br>DOMAIN: $domain<br>";

   } 
   else array_push($errors, "LDAP Error: could not determin domain");
   $domain_dn = $_SESSION['base_dn'];

   //JMD: if we're modifying an entry, get the attributes from the
   //     original entry so we don't lose posixAccount, etc...
   if($dn) {
      if(($result=ldap_read($link,$dn,"(objectclass=*)")) &&
         ($entry=ldap_first_entry($link,$result)) &&
         ($oldattrs=ldap_get_attributes($link,$entry))) {
      } else array_push($errors,"LDAP Error: could not read $dn ".ldap_error($link));
      //debug2("Original Attributes before processing",$oldattrs);

      for($i=0;$i<count($oldattrs);$i++) {
         for($j=0;$j<$oldattrs[$oldattrs[$i]]['count'];$j++) {
	    $orig_object[$oldattrs[$i]][$j]=$oldattrs[$oldattrs[$i]][$j];
         }
      }

      //JMD: get all original objectclasses
      for($i=0;$i<count($orig_object['objectClass']);$i++) {
        $oc_orig[$orig_object['objectClass'][$i]]=1;
      }
      //JMD: Make sure the kolab attributes are present, because we
      //     need the kolabDeleteflag, alias and country, which are
      //     not present in inetOrgPerson.
      if(!$oc_orig[$oc1]) { 
         //echo "<br>Adding missing $oc1 objectclass...";
         $orig_object['objectClass'][$i]=$oc1;
         $oc_orig[$orig_object['objectClass'][$i]]=1;
	 $i++;
      }
      if(!$oc_orig[$oc2]) { 
         //echo "<br>Adding missing $oc2 objectclass...";
         $orig_object['objectClass'][$i]=$oc2;
         $oc_orig[$orig_object['objectClass'][$i]]=1;
         $is_converted=1;
         $i++;
         echo "<br>Converting user to Kolab<br>";
      }
      if(!$oc_orig[$oc3]) { 
         //echo "<br>Adding missing $oc3 objectclass...";
         $orig_object['objectClass'][$i]=$oc3;
         $oc_orig[$orig_object['objectClass'][$i]]=1;
         $is_converted=1;
         echo "<br>Converting user to Kolab Extended Schema<br>";
      }
      //debug2("Original Attributes after processing",$orig_object);


      //JMD: get DN of original entry, and strip the "cn=internal" part
      //     that is used to hide entry from anonymous ldap users.
      //     This is needed so we can support DNs such as
      //     uid=betty,ou=People,dc=server,dc=domain,dc=lan
      // and uid=betty,cn=internal,ou=People,dc=server,dc=domain,dc=lan
      $orig_dn=ldap_explode_dn ($dn, $with_attrib);
      //translate hex code into ascii again
      foreach($orig_dn as $key=>$value){
         $orig_dn[$key]=preg_replace("/\\\([0-9A-Fa-f]{2})/e","''.chr(hexdec('\\1')).''", $value);
      }
      foreach($orig_dn as $key=>$value){
      }
      //debug2("DN:",$orig_dn);
      for($i=0;$i<$orig_dn['count'];$i++) {
        $rdn=$orig_dn[$i];
	if($rdn!="cn=internal") {
	   if(strpos($rdn,"uid=")===0) {
	      $uidpart.=$rdn.",";
           } elseif(strpos($rdn,"cn=")===0) {
	      $cnpart.=$rdn.",";
	   } elseif(strpos($rdn,"o=")===0) {
	      $dompart.=$rdn.",";
	   } elseif(strpos($rdn,"c=")===0) {
	      $dompart.=$rdn.",";
	   } elseif(strpos($rdn,"dc=")===0) {
	      $dompart.=$rdn.",";
	   } else {
	      $otherpart.=$rdn.",";
	   }
	}
      }
      $dompart=rtrim($dompart,',');
      //echo "<br>DN: $dn<br>";
      //echo "<br>UID: $uidpart";
      //echo "<br>CN: $cnpart";
      //echo "<br>OU: $otherpart";
      //echo "<br>DC: $dompart";
   }
   
   //JMD: include extendedschema.php if present
   if($_SESSION['extendedschema'] ) {
      @include("../include/extendedschema.php");
   }

   if ($action == "kill") {

      if (!$dn) array_push($errors, "Error: need dn for delete operation");
         elseif ($group != "maintainer" && $group != "admin") 
            array_push($errors, "Error: you need administrative permissions to delete users");

      if (!$errors) {    
         print("<TR><TD><center><H1> Delete User </H1></center></TD></TR>\n");
         $delete_template['kolabDeleteflag'] = 'TRUE';
         if (!(ldap_modify($link,$dn,$delete_template))) {
            array_push($errors, "LDAP Error: could not mark ".utf8_decode($dn)." for deletion ".ldap_error($link));
         } else {
            //system("sudo -u kolab /kolab/etc/kolab/kolab_buildconfig &");
            print("<tr><td><center> The object ".utf8_decode($dn)." has been deleted </td></tr>\n");
            //JMD: deal with groups
            include("../include/groupmod.php");
         }
      } 

   } else {

      switch ($action) {

         case "firstsave":
            if (!empty($HTTP_GET_VARS['uid_0']) &&
                uid_ok($HTTP_GET_VARS['uid_0'])) {
               $ldap_object['uid'] = trim(strtolower(urldecode($HTTP_GET_VARS['uid_0']))); 
               $ldap_object['mail'] = $ldap_object['uid']."@".$domain;
            } else {
               $comment['uid_0'] = "<span style=\"color:#FF0000\"> Fill in valid uid (lowercase <br>
	                            letters and digits only, e. g. jblack)</span>";
               missing_input();
            }
	    #if (empty($HTTP_GET_VARS['mail_0'])) {
	    #   $comment['mail_0'] = "<span style=\"color:#FF0000\"> Fill in valid email address</span>";
	    #   missing_input();
            #}

         case "save":
            if ($action == "save" && !$dn) array_push($errors, "Internal Error: need dn to save");
	    if ($group == "admin" || $group == "maintainer") {
               if (!empty($HTTP_GET_VARS['firstname'])) {
                  $firstname = trim(urldecode($HTTP_GET_VARS['firstname']));
                  //JMD: get GivenName
                  $ldap_object['givenName'] = $firstname;
               } else {
                  $comment['firstname'] = "<span style=\"color:#FF0000\"> Fill in firstname </span>";
                  missing_input();
               }
               if (!empty($HTTP_GET_VARS['lastname'])) {
                  $ldap_object['sn'] = trim(urldecode($HTTP_GET_VARS['lastname']));
                  if ($firstname) $ldap_object['cn'] = $firstname." ".$ldap_object['sn'];
               } else {
                  $comment['lastname'] = "<span style=\"color:#FF0000\"> Fill in lastname </span>";
                  missing_input();
               }
	    }   
	    //JMD: do not use urldecode on passwords, since people 
	    //     don't encode it themselves in the http form!
            if (!empty($HTTP_GET_VARS['password_0'])) $password_0 = $HTTP_GET_VARS['password_0'];
            else {
               $comment['password_0'] = "<span style=\"color:#FF0000\"> Fill in password </span>";
               missing_input();
            }
            if (!empty($HTTP_GET_VARS['password_1'])) $password_1 = $HTTP_GET_VARS['password_1'];
            else {
               $comment['password_1'] = "<span style=\"color:#FF0000\"> Fill in password </span>";
               missing_input();
            }
            if ($password_0 && $password_1) {
               if ($password_0 == $password_1) {
		  //JMD: use SSHA passwords and sync with Samba
		  if(strpos($password_0,"{SSHA}")===false) {
		     $password_0=rtrim(`/usr/sbin/slappasswd -s $password_0`);
                     $ldap_object['userPassword'] = $password_0;
                     if($_SESSION['extendedschema']) {
                        $ldap_object['sambaLMPassword']=rtrim(`/usr/sbin/kolab-mkntpwd -L $password_1`);
                        $ldap_object['sambaNTPassword']=rtrim(`/usr/sbin/kolab-mkntpwd -N $password_1`);
                        $ldap_object['sambaPwdLastSet']=rtrim(`date +%s`);
                     }
	          } else {	    
                     $ldap_object['userPassword'] = $password_0;
		  }
               } else {
                  $comment['password_1'] = "<span style=\"color:#FF0000\"> Passwords do not match </span>"; 
                  missing_input();
               }
            }

            if (!empty($HTTP_GET_VARS['mail_0'])) {
               //JMD don't use urldecode since we don't urlencode it in the
               //    first place!
               $ldap_object['mail'] = trim(strtolower($HTTP_GET_VARS['mail_0']));
	       //JMD Always check if mail is duplicate, not
	       //    only at first save!
               //if ($action == "firstsave") {
                 if (!is_unique('mail',$HTTP_GET_VARS['mail_0'],$HTTP_GET_VARS['uid_0'])) {
		    //JMD If converting from phpLDAP admin, there is no
		    //    uid, but the e-mail is there
		    if(!(empty($orig_object['uid'][0]) && $is_converted=1)) {
                      $comment['mail_0'] = "<span style=\"color:#FF0000\">email address ".$HTTP_GET_VARS['mail_0']." is already taken by another user</span>";
                      missing_input();
                    }
                 }
		 if(empty($orig_object['uid'][0]) && $is_converted=1) {
                    if(!is_unique('mail',$HTTP_GET_VARS['mail_0'],$orig_object['cn'][0],'cn')) {
                       $comment['mail_0'] = "<span style=\"color:#FF0000\">email address ".$HTTP_GET_VARS['mail_0']." is already taken by another user</span>";
                       missing_input();
                    }
                 }
                 if ($HTTP_GET_VARS['mail_0']!="" && !is_valid_email($HTTP_GET_VARS['mail_0'])) {
                   $comment['mail_0'] = "<span style=\"color:#FF0000\">email address ".$HTTP_GET_VARS['mail_0']." is invalid!</span>";
                   missing_input();
                 }
               //}
            } else {
		 //JMD: recreate it if empty
                 if($HTTP_GET_VARS['uid_0']) {
		   $ldap_object['mail'] = $HTTP_GET_VARS['uid_0']."@".$domain;
                 }
	    }
		

            foreach ($attributes as $attr) {
               if (black($attr)) continue;
               $count = 0;
               $key = $attr."_0";
               $args = array();
               while (!empty($HTTP_GET_VARS[$key])) {
                  $args[$count] = trim(urldecode($HTTP_GET_VARS[$key]));
                  $count++;
                  $key = $attr."_".$count;
               }
               if($action == "firstsave") {
                  if (!empty($HTTP_GET_VARS[$attr."_0"])) 
                     $ldap_object[$attr] = $HTTP_GET_VARS[$attr."_0"];
               } else {
                 if ($count > 0) $ldap_object[$attr] = $args;
                    elseif (!empty($HTTP_GET_VARS[$key])) $ldap_object[$attr] = $HTTP_GET_VARS[$key];
               }
            }
	    if ($group == "maintainer" || $group == "admin") {
	       //JMD Multiple aliases per user
               $aliases = split("[\n\r]+", $HTTP_GET_VARS['alias_0']);
               $goodAliases = array();
               $count = 0;
               foreach ($aliases as $alias)
               {
                   $alias = trim(urldecode($alias));
                   if (!$alias) {
                     continue;
                   }

                   //JMD: deal with aliases without domain
                   $pos=strpos($alias,'@');
                   if ($pos === false) { $alias .= "@".$domain; }

		   //echo "<br>Extracted $alias alias<br>";
		   $isgood=1;
                   if (!is_unique('alias',$alias,$HTTP_GET_VARS['uid_0'])) {
                      $comment['alias_0'].= "<br><span style=\"color:#FF0000\">$alias belongs to another user </span>";
		      missing_input();
                      $isgood=0;
		   } 
		   if (!is_unique('mail',$alias)) {
                      $comment['alias_0'].= "<br><span style=\"color:#FF0000\">$alias is another user's primary email </span>";
		      missing_input();
                      $isgood=0;
                   }
		   if (!is_valid_email($alias)) {
                      $comment['alias_0'].= "<br><span style=\"color:#FF0000\">$alias is invalid </span>";
		      missing_input();
                      $isgood=0;
                   }
                   if($isgood) {
                      $goodAliases[$count] = $alias;
                      ++$count;
                   }
               }
               if ($count > 0) {
                  $ldap_object['alias'] = $goodAliases;
               } else {
                  unset($ldap_object['alias']);
               }
               if (!empty($HTTP_GET_VARS['visible']) && $HTTP_GET_VARS['visible'] == "true") 
	          $visible = true;
	       else $visible = false;
	    }   
            if (!$visible) $dn_add = "cn=internal,";
               else $dn_add = "";
//print("ldap_object: "); print_r($ldap_object); print("<br>");

	    if (!empty($ldap_object['uid']) && !is_unique('uid',$ldap_object['uid'])) {
	       $comment['uid_0'] = "<span style=\"color:#FF0000\"> Error: This uid is already taken by another user </span>";
	       missing_input();
	    }

	    #if (!is_unique('alias',$HTTP_GET_VARS['alias_0'],$HTTP_GET_VARS['uid_0'])) {
	    #   $comment['alias_0'] = "<span style=\"color:#FF0000\"> Error: the alias you gave is <br>". 
	    #   			     "already taken by another user</span>";
	    #   missing_input();
	    #}
            #if ($HTTP_GET_VARS['alias_0']!="" && !is_valid_email($HTTP_GET_VARS['alias_0'])) {
            #   $comment['alias_0'] = "<span style=\"color:#FF0000\">alias is invalid!</span>";
            #   missing_input();
            #}

            $ldap_object = to_utf8($ldap_object);
	    //JMD action == "firstsave"
            if($action == "firstsave") {
	       if (!empty($ldap_object['cn']) && !is_unique('cn',$ldap_object['cn'])) {
		 //JMD: complain for duplicate name only if we don't use 
		 //     uid as LDAP index.
		 if($HTTP_SESSION_VARS['defaultkey'] != "uid") {
	            $comment['firstname'] = "<span style=\"color:#FF0000\"> Error: This name already exists! Please enter initial, second name, etc., to distinguish between the other person of same name.</span>";
	            missing_input();
		 }
	       }
            }
            if ($action == "save") {
               if (!$errors) {
		  //JMD: if we're using a uid=... schema, don't
		  //     modify the cn even if the name changes
                  if (!empty($ldap_object['cn']) && empty($uidpart)) {
		     $newdn = "cn=".$ldap_object['cn'].",";
		     $newdn.= $dn_add.$otherpart.$dompart;
		  } else {
		     $newdn = $uidpart.$cnpart.$dn_add.$otherpart.$dompart;
		  }
		  //JMD 
		  //echo "<br>Old DN: $dn<br>New DN: $newdn<br>";
                  if (strcmp($dn,$newdn) != 0) {
		     //JMD Get all the attributes, even if kolab
		     //    doesn't support them. This is really
		     //    important, since we add a new user
		     //    and delete the old one.
		     //debug2("Before:",$ldap_object);
		     foreach($orig_object as $key => $value) {
			if(!$ldap_object[$key]) {
			   //echo "<br>Adding missing attribute $key...";
			   $ldap_object[$key]=$orig_object[$key];
			}
		     }
                     $ldap_object['uid'] = $orig_object['uid'][0];
		     //JMD handle conversion from phpLDAPadmin
		     if(empty($ldap_object['uid'])) {
		        $ldap_object['uid']=$HTTP_GET_VARS['uid_0'];
                     }
                     //JMD: process extended schema
                     if($_SESSION['extendedschema']) {
                        @include("../include/extendedschemacheck.php");
                     }
		     //JMD: use the original objectClass, since this
		     //     is a modification to an original user
		     $ldap_object['objectClass']=$orig_object['objectClass'];			
		     //debug2("After:",$ldap_object);
                     if(empty($ldap_object['uid'])) {
                        missing_input();
                     } else {
                        if (!ldap_add($link,$newdn, $ldap_object) || !ldap_delete($link,$dn)) {
                          array_push($errors, "LDAP Error: could not rename $dn to $newdn ".ldap_error($link));
                        } else {
                          $dn = $newdn;
                          //JMD: deal with groups
                          include("../include/groupmod.php");
                        }
                     }
                  } else {
                     $ldap_object = fill_up($ldap_object);
                     if ($group == "user") {
                        unset($ldap_object['sn']);
                        unset($ldap_object['cn']);
                     }
                     //JMD: process extended schema
                     if($_SESSION['extendedschema']) {
                        @include("../include/extendedschemacheck.php");
                     }
		     //JMD: use the original objectClass, since this
		     //     is a modification to an original user
		     $ldap_object['objectClass']=$orig_object['objectClass'];			
		     //debug2("After:",$ldap_object);
                     if (!ldap_modify($link, $dn, $ldap_object)) {
                       array_push($errors, "LDAP Error: could not modify object $dn ".ldap_error($link)); 
                     } else {
                       //JMD: deal with groups
                       include("../include/groupmod.php");
                     }
                  }
               } 
            } else {
               if (!$errors) {

		  //JMD: Check if we use cn=... or uid=...
		  //     Define in session_vars.php.template
		  if($HTTP_SESSION_VARS['defaultkey']=="uid") {
		     $dn = "uid=".$ldap_object['uid'].",".$dn_add;
		  } else {
		     $dn = "cn=".$ldap_object['cn'].",".$dn_add;
		  }
		  //JMD: Check if we use additional stuff like ou=People
		  //	 Define in session_vars.php.template
		  if($HTTP_SESSION_VARS['defaultou']) {
		     $dn .= rtrim($HTTP_SESSION_VARS['defaultou'],',').",";
		  }
                  $dn.=$domain_dn;
                  if($_SESSION['extendedschema']) {
                     @include("../include/extendedschemacheck.php");
                  }
                  if ($dn && !ldap_add($link, $dn, $ldap_object)) {
                     array_push($errors, "LDAP Error: could not add object $dn ".ldap_error($link));
                  } else {
                     //else system("sudo -u kolab /kolab/etc/kolab/kolab_buildconfig &");
                     //JMD: deal with groups
                     include("../include/groupmod.php");
                  }
               }
               if ($errors) {
                  print("<TR><TD><center><H1> Create New User </H1></center></TD></TR>\n");
 		  $blacklist = array('mail');
		  $action = "create";
		  $ldap_object = from_utf8($ldap_object);
                  break;
               }
            }
	    if($action=="firstsave") {
	      $action="create";
              print("<TR><TD><center><span style=\"color:#0000FF\"><H1>User Added!</H1></span><H1>Create New User</H1></center></TD></TR>\n");
	      unset($ldap_object);
	      unset($dn);
	      unset($cn);
	      unset($firstname);
              //JMD: this is needed with my modifications, and is
              //     safer anyways
              unset($HTTP_GET_VARS);
	    } else {
              $action = "modify";
	      //JMD: if there are errors, don't tell changes are accepted!
              if(empty($errors)) {
                print("<TR><TD><center><span style=\"color:#0000FF\"><H1> Changes Accepted!</H1></span></center></TD></TR>\n");
              } else {
                print("<TR><TD><center><span style=\"color:#FF0000\"><H1> Changes Not Accepted!</H1></span></center></TD></TR>\n");
	      }

            }
            break;

         case "create":
            print("<TR><TD><center><H1> Create New User </H1></center></TD></TR>\n");
            $blacklist = array('mail');
            break;

         case "modify":
            print("<TR><TD><center><H1> Modify Existing User </H1></center></TD></TR>\n");
	    break;

	 case "delete":
	    print("<TR><TD><center><H1> Confirm Delete User </H1></center></TD></TR>\n");
      }

      if ($dn) {
         $ldap_object = array();
         if (($result = ldap_read($link, $dn, "(objectclass=*)")) &&
             ($entry = ldap_first_entry($link,$result)) &&
             ($ldap_object = ldap_get_attributes($link,$entry))) {
            $ldap_object = from_utf8($ldap_object);
            $ldap_object = fill_up2($ldap_object);
            ldap_free_result($result);
         } else array_push($errors, "LDAP Error: could not read $dn ".ldap_error($link));
      }
   }
   ldap_close($link);
}   

$width = 50;

//print "ldap_object gelesen: "; print_r($ldap_object); print "<br>";

if (in_array($action, $valid_actions) && $action != "kill") {
print "<TR><TD><CENTER><form action=\"$myself\" method=\"GET\">\n";
switch ($action) {
   case "create":
      print("<input type=\"hidden\" name=\"action\" value=\"firstsave\">\n");
      break;
   case "delete":
      print("<input type=\"hidden\" name=\"action\" value=\"kill\">\n");
      break;
   default:
      print("<input type=\"hidden\" name=\"action\" value=\"save\">\n");
}
if ($dn) print "<input type=\"hidden\" name=\"dn\" value=\"$dn\">\n";
print "<table cellspacing=0 cellpadding=3>\n";

if (is_array($ldap_object['sn'])) $lastname = $ldap_object['sn'][0];
   else $lastname = $ldap_object['sn']; 
if (is_array($ldap_object['cn'])) $cn = $ldap_object['cn'][0];
   else $cn = $ldap_object['cn'];
if ($lastname) {
   $a = strlen($lastname); 
   if ($cn) {
      $b = strlen($cn);
      //JMD: get rid of the extra space and deal with the possibility
      //     that cn might not contain last name
      if(strpos($cn,$lastname)>0) {
         $firstname = rtrim(substr($cn, 0, $b - $a));
      } else if(strpos($cn,$lastname)===0) {
         $firstname = ltrim(substr($cn, $a-$b, $b));
      } else {
         $firstname = rtrim($cn);
      }
   }
}
if ($action == "delete") print("<tr><th> Attribute </th><th> Value </th></tr>\n");
else print("<tr><th> Attribute </th><th> Value </th><th> Comment </th></tr>\n");
print "<tr><td> First Name </td><td>\n";
if ($action == "delete") print("$firstname </td></tr>\n");
else {
   if ($group == "admin" || $group == "maintainer") {
      print "<input type=\"text\" name=\"firstname\" size=$width maxlength=80 value=\"$firstname\">\n";
      print "</td><td>".(comment('firstname'))."</td></tr>\n";
   } else print("$firstname </td><td> &nbsp; </td></tr>\n");
}

print "<tr><td> Last Name </td><td>\n";
if ($action == "delete") print("$lastname </td></tr>\n");
else {
   if ($group == "admin" || $group == "maintainer") {
      print "<input type=\"text\" name=\"lastname\" size=$width maxlength=80 value=\"$lastname\">\n";
      //JMD: fix typo, comment is lastname, not sn_0
      print "</td><td>".(comment('lastname'))."</td></tr>\n";
   } else print("$lastname </td><td> &nbsp; </td></tr>\n");
}

if ($action != "delete") {
   if (is_array($ldap_object['userPassword'])) $password_0 = $password_1 = $ldap_object['userPassword'][0];
      else $password_0 = $password_1 = $ldap_object['userPassword'];
   //JMD permit import from from phpLDAPadmin or other wizards
   //    that don't have a password
   if(empty($password_0) && empty($password_1)) {
         $password_0=$HTTP_GET_VARS['password_0'];
         $password_1=$HTTP_GET_VARS['password_1'];
   }
   if($action != "create" && empty($password_0) && empty($password_1)) {
         $comment['password_0'] = "<span style=\"color:#FF0000\"> Required </span>";
         $comment['password_1'] = "<span style=\"color:#FF0000\"> Required </span>";
   }
   print "<tr><td> Password </td><td>\n";
   print "<input type=\"password\" name=\"password_0\" size=$width maxlength=80 value=\"$password_0\">\n";
   print "</td><td>".(comment('password_0'))."</td></tr>\n";
   print "<tr><td> Verify Password </td><td>\n";
   print "<input type=\"password\" name=\"password_1\" size=$width maxlength=80 value=\"$password_1\">\n";
   print "</td><td>".(comment('password_1'))."</td></tr>\n";
   print "<tr><td> UserName</td><td>\n";
   if (is_array($ldap_object['uid'])) $uid_0 = $ldap_object['uid'][0];
      else $uid_0 = $ldap_object['uid'];
   print "<input type=\"text\" ";
   //JMD permit import from phpLDAPadmin or other wizards
   //    that use inetOrgPerson with an empty uid.
   if(empty($uid_0)) {
      if($group=="admin" || $group=="maintainer") {
	 $uid_0=$HTTP_GET_VARS['uid_0'];
	 if(empty($uid_0)) {
 	    if($action != "create" && $action != "firstsave") {
               $comment['uid_0'] = "<span style=\"color:#FF0000\"> Fill in valid uid (lowercase <br>
	          letters and digits only, e. g. jblack)</span>";
            }
         }
      } else {
         print " readonly ";
      }
   } else if ($action != "create" ) { 
     print " readonly "; 
   } 
   print "name=\"uid_0\" size=$width maxlength=80 value=\"$uid_0\">\n";
   print "<td>".(comment('uid_0'))."</td></tr>\n";

   //JMD: enable box for system user
   include("../include/systemuser.php");

   print "<tr><td> Primary E-mail</td><td>\n";
   if (is_array($ldap_object['mail'])) $mail_0 = $ldap_object['mail'][0];
      else $mail_0 = $ldap_object['mail'];
   print "<input type=\"text\" ";
   print "name=\"mail_0\" size=$width maxlength=80 value=\"$mail_0\">\n";
   print "<td>".(comment('mail_0'))."</td></tr>\n";
   print "<tr><td valign=top>  E-Mail Aliases </td><td>\n";
   //JMD Multiple Aliases
   if (isset($ldap_object['alias']) && is_array($ldap_object['alias'])) {
      $aliases = $ldap_object['alias'];
      $count = $aliases['count'];
      unset($alias_0);
      for ($i = 0; $i < $count; ++$i)
      {
         $value = trim($aliases[$i]);
         if ($value)
         {
            $alias_0 .= "$value\n";
         }
      }
   } else if (isset($ldap_object['alias'])) {
      $alias_0 = $ldap_object['alias'];
   }
   else
   {
       $alias_0 = "";
   }
   print "<textarea cols=35 rows=3 name=\"alias_0\"";
   if ( ($group != "admin") && ($group != "maintainer") )
   {
      print " readonly";
   }
   print ">$alias_0</textarea>";
   print "<td valign=top>".(comment('alias_0'))."</td></tr>\n";

}

foreach ($attributes as $attr) {
   if (noshow($attr)) continue;
   if (!empty($ldap_object[$attr])) {
      if (is_array($ldap_object[$attr])) $value = $ldap_object[$attr];
         else $value = array(0 => $ldap_object[$attr], 'count' => 1);
   } else $value = array( 0 => "", 'count' => 1);
   for ($count=0; $count<$value['count']; $count++) {
      $battr = dobeautify($attr);
      //JMD: some organizations don't want to show user data
      if($group=="user" && $_SESSION['minimaledit']=="yes") $battr="";
      print "<tr><td> $battr </td><td>\n";
      if ($action != "delete") {
         if (!black($attr)) {
            //JMD: some organizations don't want to show user data
            if($group=="user" && $_SESSION['minimaledit']=="yes") {
               print "<input type=\"hidden\" name=\"".$attr."_".$count."\" size=$width maxlength=80 value=\"".$value[$count]."\">\n";
            } else {
               print "<input type=\"text\" name=\"".$attr."_".$count."\" size=$width maxlength=80 value=\"".$value[$count]."\">\n";
            }
         } else {
            if ($value[$count]) print "$value[$count]";
               else print "(not set)";
         }
         print "</td><td>".(comment($attr."_".$count))."</td></tr>\n";
      } else print($value[$count]." </td></tr>\n");
      $count++;
   }
}
if ($action != "delete") {
   if ($group == "admin" || $group == "maintainer") {
      print("<tr><td>Addressbook</td><td><input type=\"checkbox\" name=\"visible\" value=\"true\" ");
      if ($visible) print("checked");
      print("></td>\n");
      print "<td>".(comment('visible'))."</td></tr>\n";
   }
}

print "</table></CENTER></TD><TR>\n";

print "<tr><td><center><table cellspacing=0 cellpadding=3>\n";
print "<tr><td><input type=\"image\" src=\"../pics/button_ok.png\" name=\"apply\" value=\"Apply\"></td>\n";
if ($group == "user") {
   print "<td><a href=\"..\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
} else {
   print "<td><a href=\"index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
}
print "</center></td></tr>\n";

} // if $action != delete

print("</table>\n");

if ($errors) {
   print("<TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n");
   print("<TR><TD HEIGHT=20></TD></TR>\n");
   print("<TR><TD><H3> There were Errors : </H3></TD></TR>\n");
   print("<TR><TD>\n");
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>");
   print("</TD></TR>\n");
   print("</TABLE>\n");
}
Foot();
?>
