<?
/*
 (c) 2003 Tassilo Erlewein <tassilo.erlewein@erfrakon.de>
 (c) 2003 Martin Konold <martin.konold@erfrakon.de>
 (c) 2004 Jean-Michel Dault <jmdault@mandrakesoft.com>
 This program is Free Software under the GNU General Public License (>=v2).
 Read the file COPYING that comes with this packages for details.
*/
  include("head.php");
  This("user/vacation");
  Head();
?>

<TABLE border=0 WIDTH="100%" CELLSPACING=8 CELLPADDING=8>
<TR><TD HEIGHT=20></TD></TR>
<TR><TD><center><H1>My User Forward Settings</H1></center></TD></TR>

<?

include("../include/sieve-php.lib");
include("../include/sieve-functions.php");
include("../include/checks.php");

$errors = array();

// check user authentication 
if (!($uid = $_SERVER["PHP_AUTH_USER"]) ||
    !($bind_dn = uid2dn($uid)) ||
    !($group = uid2group($uid))) 
   array_push($errors, "Internal Error: could not get UID Authentication Information");

if (!($passwd = $_SERVER["PHP_AUTH_PW"]))
   array_push($errors, "Internal Error: could not get Password Authentication Information");
   
if (!$errors && $group != "user" ) 
   array_push($errors, "Error: You don't have Permissions to access this Menue");

// DEBUG:
//print "HTTP_GET_VARS: ";
//print_r($HTTP_GET_VARS);

// read selector for register display
if (isset($HTTP_GET_VARS['action'])) $action = $HTTP_GET_VARS['action'];
   else $action = "start";

//JMD: don't send mail to nodoby@kde.org by default!
//     use example.com from RFC 2606 (Reserved Top Level DNS Names)
if (isset($HTTP_GET_VARS['email'])) $email = $HTTP_GET_VARS['email'];
   else $email = "nobody@example.com";

//JMD: the negation was missing
if (!(email_address_ok($email))) {
   //print "You entered an invalid E-Mail address";
   $action = "start";
   $wrong_email = TRUE;
}

if (isset($HTTP_GET_VARS['keep'])) $keep = $HTTP_GET_VARS['keep'];

$myself = $_SERVER['PHP_SELF'];

if (isset($_SESSION['sieve_server'])) $sieve_server = $_SESSION['sieve_server'];
   else $sieve_server = '127.0.0.1';

if (isset($_SESSION['sieve_port'])) $sieve_port = $_SESSION['sieve_port'];
   else $sieve_port = 2000;

$sieve=new sieve($sieve_server, $sieve_port, $uid, $passwd, $uid);

// this is the name KDE client stores - so we can also change the setting from KDE client
$scriptname = "kmail-vacation.siv";


if (!($sieve->sieve_login()))
   array_push($errors,"Could not log on to timsieved daemon on your IMAP server sieve://$sieve_server:$sieve_port");

if (!$errors) {
   // on start show if sieve script is present or not
   if ($sieve->sieve_listscripts())  {
      if ($action == "start") 
         print("<TR><TD><center>Vacation notification or email forwarding
already activated</center></TD></TR>");
      $sieveactive = TRUE;
   } else {
      if ($action == "start") 
         print("<tr><td><center>Currently no forwarding of email activated</center></td></tr>");
      $sieveactive = FALSE;
   }
   
   switch ($action) {
       case "create":
//          print("\naction: $action.\n\n");
          if ($sieveactive == TRUE) {
             delete_script ($scriptname);
	     print "<tr><td><center>Vacation notification or email forwarding
                    directive got deleted on server</center></td></tr>";
          }
	  
          $newscript = "redirect \"$email\";\n";
	  if ($keep == "keep")
	     $newscript .= "keep;\n";

          upload_script ($newscript,$scriptname);
	  
          if(!($sieve->sieve_setactivescript($scriptname)))
              array_push($errors,"Could not upload and activate forward directive on your IMAP server!");
	      
	  print "<tr><td><center>Forwarding to email address activated</center></td></tr>\n";
	  print "<tr><td><center>E-Mail sent to you will be redirected to $email<center></td></tr>\n";
	  if ($keep == "keep")
	     print "<tr><td><center>E-Mails will also kept stored on the server<center></td></tr>\n";
	  print "</table>";

          print "<CENTER><TABLE WIDTH=\"10%%\" CELLSPACING=0 CELLPADDING=0 BORDER=0>\n";
	  print "<TR><TD HEIGHT=20></TD></TR>\n";
          print "<TR><TD><form action=\"$myself\" method=\"GET\">\n";
	  print "<td><a href=\"../index.php\"> <img src=\"../pics/button_ok.png\" alt=\"OK\"></a></td></tr>\n";
          print "</table></form></center>\n";
          print "</td></tr>\n";
       break;
       
       case "delete":
//          print("\naction: $action.\n\n");
          if ($sieveactive == TRUE) {
             delete_script ($scriptname);
	     print "<tr><td><center>Deleted vacation or forward directive on server</center></td></tr></table>\n";
          } else {
	     print "<tr><td><center>No vacation or forward directive on server found to be deleted!</center></td></tr></table>\n";
          }

          print "<CENTER><TABLE WIDTH=\"10%%\" CELLSPACING=0 CELLPADDING=0 BORDER=0>\n";
	  print "<TR><TD HEIGHT=20></TD></TR>\n";
          print "<TR><TD><form action=\"$myself\" method=\"GET\">\n";
	  print "<td><a href=\"$myself\"> <img src=\"../pics/button_ok.png\" alt=\"OK\"></a></td></tr>\n";
	  print "<input type=\"hidden\" name=\"action\" value=\"start\">\n";
          print "</table></form></center>\n";
          print "</td></tr>\n";
       break;
       
       default:
//          print("\naction: $action.\n\n");
          if ($sieve->sieve_listscripts()) {
	     $action = "firstdelete";
	  } else {
	     $action = "firstcreate";
	  }

          print "<TR><TD><CENTER><form action=\"$myself\" method=\"GET\">\n";
          print "<table cellspacing=0 cellpadding=3>\n";
	  print "<TR><TD HEIGHT=20></TD></TR>\n";

          if ($action == "firstcreate") {
             print "<tr><th> </th><th></th><th></th></tr>\n";
             if ($wrong_email) {
	        print "<tr><td></td><td><blockquote><font color=#aa0000>";
	        print "The E-Mail address you entered is not correct - please change!</font></blockquote>";
		print "</font></blockquote></td><td></td></tr>";
                $wrong_email = FALSE;
             }
     print "<tr><td>Forward my email to</td>\n";
     print "<td align=\"left\"><input type=\"text\" name=\"email\" size=25 maxlength=80 value=\"$email\"></td></tr>\n";
             print "<tr>\n";
	     print "<td>Keep copy on server</td><td align=\"left\"><input type=\"checkbox\" name=\"keep\" value=\"keep\"></td>\n";
             print "</tr>\n";
             print "</table></CENTER>\n";

             print "<tr><td><center><table width=\"60%\" cellspacing=10 cellpadding=10><tr>\n";
	     print "<TR><TD HEIGHT=20></TD></TR>\n";
             print "<input type=\"image\" src=\"../pics/button_ok.png\" name=\"create\" alt=\"create\" value=\"Apply\">\n";
	     print "<input type=\"hidden\" name=\"action\" value=\"create\">\n";
             print "<a href=\"../index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
             print "</table></CENTER>\n";
          } else {
	     // delete the script on the server before setting a new one...
	     print "<tr><td>Please delete the currently active your vacation
                    notification or email forward setting by pressing the OK button! 
                   </td></tr>\n";
	     print "</table>\n";
             print "<TABLE WIDTH=\"30%%\" CELLSPACING=0 CELLPADDING=0 BORDER=0>\n";
	     print "<TR><TD HEIGHT=20></TD></TR>\n";
	     print "<tr><td><input type=\"image\" src=\"../pics/button_ok.png\" name=\"delete\" value=\"Apply\"></td>\n";
	     print "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
	     print "<td><a href=\"../index.php\"> <img src=\"../pics/button_cancel.png\" alt=\"cancel\"></a></td></tr>\n";
	  }
          // close the centered table form
          print "</table></form></center>\n";
          print "</td></tr>\n";
   }
   $sieve->sieve_logout();
}

if ($errors) {
   print "<TR><TD><TABLE WIDTH=\"100%\" CELLSPACING=20 CELLPADDING=0 BORDER=0>\n";
   print "<TR><TD HEIGHT=20></TD></TR>\n";
   print "<TR><TD><H3> There were Errors : </H3></TD></TR>\n";
   print "<TR><TD>\n";
   foreach ($errors as $message) print("<span style=\"color:#FF0000\">".$message."</span><br>"); 
   print "</TD></TR>\n";
   print "</TABLE>\n";
   print "</TD></TR>\n";
}
?>

</TABLE>

<?php
Foot(); 
?>
